SystemOrganization addCategory: #'Grease-Tests-Core'!

GRError subclass: #GRErrorStub
	instanceVariableNames: 'foo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRErrorStub methodsFor: 'accessing' stamp: 'jf 3/13/2009 16:56'!
foo
	^ foo! !

!GRErrorStub methodsFor: 'initialization' stamp: 'jf 3/13/2009 16:56'!
initialize
	super initialize.
	foo := true! !

GRObject subclass: #GRObjectStub
	instanceVariableNames: 'foo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRObjectStub methodsFor: 'accessing' stamp: 'jf 2/3/2009 15:19'!
foo
	^ foo! !

!GRObjectStub methodsFor: 'initialization' stamp: 'jf 2/3/2009 15:19'!
initialize
	super initialize.
	foo := true! !

!GRPackage class methodsFor: '*grease-tests-core' stamp: 'jf 9/30/2009 01:12'!
greaseTestsCore
	^ self new
		name: 'Grease-Tests-Core';
		description: 'Unit tests for the package Grease-Core.';
		addDependency: 'Grease-Core';
		yourself! !

GRNotification subclass: #GRNotificationStub
	instanceVariableNames: 'foo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRNotificationStub methodsFor: 'accessing' stamp: 'jf 11/3/2009 00:45'!
defaultAction
	^ #returnValue! !

!GRNotificationStub methodsFor: 'accessing' stamp: 'jf 3/13/2009 16:56'!
foo
	^ foo! !

!GRNotificationStub methodsFor: 'initialization' stamp: 'jf 3/13/2009 16:56'!
initialize
	super initialize.
	foo := true! !

TestCase subclass: #GRCodecTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRCodecTest methodsFor: 'private' stamp: 'dkh 11/13/2009 15:24'!
asString: aCollectionOfIntegers
	^String streamContents: [ :stream |
		aCollectionOfIntegers do: [ :each |
			stream nextPut: (Character codePoint: each) ] ]! !

!GRCodecTest methodsFor: 'accessing' stamp: 'dkh 11/13/2009 15:24'!
latin1String
	^ self asString: #(220 98 232 114 115 116 114 238 241 103 233)! !

!GRCodecTest methodsFor: 'accessing' stamp: 'dkh 11/13/2009 15:24'!
macromanString
	^ self asString: #(134 98 143 114 115 116 114 148 150 103 142)! !

!GRCodecTest methodsFor: 'testing' stamp: 'dkh 11/13/2009 15:24'!
testAllCodecs
	self assert: GRCodec allCodecs notEmpty.
	GRCodec allCodecs do: 
		[ :codec | 
		self deny: codec class = GRCodec.
		self assert: (codec isKindOf: GRCodec) ]! !

!GRCodecTest methodsFor: 'testing' stamp: 'dkh 11/13/2009 15:24'!
testCodecLatin1
	#('iso-8859-1' 'ISO-8859-1' ) do: 
		[ :each | 
		| codec |
		codec := GRCodec forEncoding: each.
		self assert: codec name = each.
		self assert: codec url name = each.
		self assert: (codec encode: self latin1String) = self latin1String.
		self assert: (codec url encode: self latin1String) = self latin1String.
		self assert: (codec decode: self latin1String) = self latin1String.
		self assert: (codec url decode: self latin1String) = self latin1String ]! !

!GRCodecTest methodsFor: 'testing' stamp: 'dkh 11/13/2009 15:24'!
testCodecLatin1Binary
	| codec encoder binary |
	codec := GRCodec forEncoding: 'ISO-8859-1'.
	binary := self latin1String asByteArray.
	encoder := codec encoderFor: (WriteStream on: String new).
	encoder binary.
	encoder nextPutAll: binary.
	self assert: encoder contents = binary asString! !

!GRCodecTest methodsFor: 'testing' stamp: 'dkh 11/13/2009 15:24'!
testNullCodec
	| codec readStream writeStream strings |
	codec := GRNullCodec new.
	readStream := self latin1String readStream.
	writeStream := WriteStream on: String new.
	strings := OrderedCollection new
		add: self latin1String;
		add: self utf8String;
		add: self utf16leString;
		add: self utf16beString;
		add: self macromanString;
		yourself.
	strings do: 
		[ :string | 
		self assert: (codec encode: string) = string.
		self assert: (codec url encode: string) = string.
		self assert: (codec decode: string) = string.
		self assert: (codec url decode: string) = string ].
	strings do: 
		[ :string | 
		| binary encoded |
		binary := string asByteArray.
		encoded := (codec encoderFor: (WriteStream on: String new))
			binary;
			nextPutAll: binary;
			contents.
		self assert: encoded = string.
		encoded := (codec url encoderFor: (WriteStream on: String new))
			binary;
			nextPutAll: binary;
			contents.
		self assert: encoded = string ]! !

!GRCodecTest methodsFor: 'accessing' stamp: 'dkh 11/13/2009 15:24'!
utf16beString
	^ self asString: #(0 220 0 98 0 232 0 114 0 115 0 116 0 114 0 238 0 241 0 103 0 233)! !

!GRCodecTest methodsFor: 'accessing' stamp: 'dkh 11/13/2009 15:24'!
utf16leString
	^ self asString: #(220 0 98 0 232 0 114 0 115 0 116 0 114 0 238 0 241 0 103 0 233 0)! !

!GRCodecTest methodsFor: 'accessing' stamp: 'dkh 11/13/2009 15:24'!
utf8String
	^ self asString: #(195 156 98 195 168 114 115 116 114 195 174 195 177 103 195 169)! !

TestCase subclass: #GRCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRCollectionTest methodsFor: 'tests' stamp: 'jf 9/24/2009 13:29'!
testAddFirst
	| strings |
	strings := #('b' 'c' 'd') asOrderedCollection.
	strings addFirst: 'a'.
	self assert: strings = (OrderedCollection new
		add: 'a';
		add: 'b';
		add: 'c';
		add: 'd';
		yourself)! !

!GRCollectionTest methodsFor: 'tests' stamp: 'jf 2/6/2010 00:40'!
testAny
	| array set bag dictionary ordered string |
	array := #(1 2 3).
	set := Set with: 1 with: 2.
	bag := Bag with: 1 with: 2.
	dictionary := Dictionary new at: #a put: 1; at: #b put: 2; yourself.
	ordered := OrderedCollection with: 1 with: 2.
	string := 'abcdef'.
	
	self assert: (array includes: array any).
	self assert: (set includes: set any).
	self assert: (bag includes: bag any).
	self assert: (dictionary values includes: dictionary any).
	self assert: (ordered includes: ordered any).
	self assert: (string includes: string any).! !

!GRCollectionTest methodsFor: 'tests' stamp: 'jf 9/24/2009 13:29'!
testAssociationsDo
	| actual |
	actual := Array with: 1->1 with: 2->2 with: 3->3.
	actual associationsDo: [:assoc | self assert: (assoc key = assoc value)].
	
	actual := actual asOrderedCollection.
	actual associationsDo: [:assoc | self assert: (assoc key = assoc value)].! !

!GRCollectionTest methodsFor: 'tests' stamp: 'jf 9/25/2009 17:03'!
testCopyUpTo
	| array interval strings |
	array := #(1 2 3 4 1 2 3).
	self assert: (array copyUpTo: 1) = #().
	self assert: (array copyUpTo: 3) = #(1 2).
	self assert: (array copyUpTo: 5) = array.
	
	interval := 1 to: 4.
	self assert: (interval copyUpTo: 1) = #().
	self assert: (interval copyUpTo: 3) = #(1 2).
	self assert: (interval copyUpTo: 5) = #(1 2 3 4).
	
	"Make sure we're using equality"
	strings := #(1 '1' '1').
	self assert: (strings copyUpTo: '1') = #(1).! !

!GRCollectionTest methodsFor: 'tests' stamp: 'jf 9/25/2009 17:05'!
testCopyUpToLast
	| array interval strings |
	array := #(1 2 3 4 1 2).
	self assert: (array copyUpToLast: 1) = #(1 2 3 4).
	self assert: (array copyUpToLast: 3) = #(1 2).
	self assert: (array copyUpToLast: 5) = array.
	
	interval := 1 to: 4.
	self assert: (interval copyUpToLast: 1) = #().
	self assert: (interval copyUpToLast: 3) = #(1 2).
	self assert: (interval copyUpToLast: 5) = #(1 2 3 4).
	
	"Make sure we're using equality"
	strings := #(1 '1' '1').
	self assert: (strings copyUpToLast: '1') = #(1 '1').! !

!GRCollectionTest methodsFor: 'tests' stamp: 'jf 2/6/2010 01:27'!
testEmptyAny
	| array set bag dictionary ordered string |
	array := #().
	set := Set new.
	bag := Bag new.
	dictionary := Dictionary new.
	ordered := OrderedCollection new.
	string := ''.
	
	self should: [ array includes: array any ] raise: Error.
	self should: [ set includes: set any ] raise: Error.
	self should: [ bag includes: bag any ] raise: Error.
	self should: [ dictionary values includes: dictionary any ] raise: Error.
	self should: [ ordered includes: ordered any ] raise: Error.
	self should: [ string includes: string any ] raise: Error.! !

!GRCollectionTest methodsFor: 'tests' stamp: 'jf 9/24/2009 14:03'!
testInPlaceArraySort
	| array |
	array := Array withAll: #(2 4 3 1).
	array sort.
	self assert: array = #(1 2 3 4).
	array sort: [:a :b | a > b].
	self assert: array = #(4 3 2 1)! !

!GRCollectionTest methodsFor: 'tests' stamp: 'jf 9/24/2009 13:31'!
testNoneSatisfy
	self assert: ( #(1 3 5 7 9) noneSatisfy: [ :each | each even ] ).
	self deny: ( #(1 3 5 7 9 4) noneSatisfy: [ :each | each even ] ).
	self assert: ( #() noneSatisfy: [:each | true ])! !

!GRCollectionTest methodsFor: 'tests' stamp: 'jf 9/24/2009 13:31'!
testNotEmpty
	
	self assert: #(1) notEmpty.
	self deny:  #() notEmpty.
	self assert: '1' notEmpty.
	self deny:  '' notEmpty! !

TestCase subclass: #GRDelayedSendTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRDelayedSendTest methodsFor: 'testing-accessing' stamp: 'jf 9/30/2009 00:22'!
testArgumentCount
	" unary "
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #negated.
	self assert: send argumentCount = 0.
	send := GRDelayedSend 
		receiver: 1
		selector: #negated
		arguments: #().
	self assert: send argumentCount = 0.

	" binary "
	send := GRDelayedSend 
		receiver: 1
		selector: #+.
	self assert: send argumentCount = 1.
	send := GRDelayedSend 
		receiver: 1
		selector: #+
		argument: 2.
	self assert: send argumentCount = 0.

	" keyword "
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:.
	self assert: send argumentCount = 2.
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		argument: 2.
	self assert: send argumentCount = 1.
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		arguments: (Array 
				with: 2
				with: 3).
	self assert: send argumentCount = 0! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:22'!
testFixCallbackTemps
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #+.
	self assert: send fixCallbackTemps == send.
	send := GRDelayedSend 
		receiver: 1
		selector: #+
		argument: 2.
	self assert: send fixCallbackTemps == send! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:24'!
testValueBinary
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #+.
	self 
		should: [ send value ]
		raise: GRInvalidArgumentCount.
	send := GRDelayedSend 
		receiver: 1
		selector: #+
		argument: 2.
	self assert: send value = 3! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:24'!
testValueKeyword
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:.
	self 
		should: [ send value ]
		raise: GRInvalidArgumentCount.
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		argument: 2.
	self 
		should: [ send value ]
		raise: GRInvalidArgumentCount.
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		arguments: (Array 
				with: 2
				with: 3).
	self deny: send value! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:22'!
testValueUnary
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #negated.
	self assert: send value = -1.
	send := GRDelayedSend 
		receiver: 1
		selector: #negated
		arguments: #().
	self assert: send value = -1! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:24'!
testValueValueBinary
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #+.
	self 
		should: 
			[ send 
				value: 2
				value: 3 ]
		raise: GRInvalidArgumentCount.
	send := GRDelayedSend 
		receiver: 1
		selector: #+
		argument: 2.
	self 
		should: 
			[ send 
				value: 2
				value: 3 ]
		raise: GRInvalidArgumentCount! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:24'!
testValueValueKeyword
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:.
	self deny: (send 
			value: 2
			value: 3).
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		argument: 2.
	self 
		should: 
			[ send 
				value: 4
				value: 5 ]
		raise: GRInvalidArgumentCount.
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		arguments: (Array 
				with: 2
				with: 3).
	self 
		should: 
			[ send 
				value: 4
				value: 5 ]
		raise: GRInvalidArgumentCount! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:24'!
testValueValueUnary
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #negated.
	self 
		should: 
			[ send 
				value: 2
				value: 3 ]
		raise: GRInvalidArgumentCount.
	send := GRDelayedSend 
		receiver: 1
		selector: #negated
		arguments: #().
	self 
		should: 
			[ send 
				value: 2
				value: 3 ]
		raise: GRInvalidArgumentCount! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:24'!
testValueWithArgumentBinary
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #+.
	self assert: (send value: 2) = 3.
	send := GRDelayedSend 
		receiver: 1
		selector: #+
		argument: 2.
	self 
		should: [ send value: 2 ]
		raise: GRInvalidArgumentCount! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:24'!
testValueWithArgumentKeyword
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:.
	self 
		should: [ send value: 2 ]
		raise: GRInvalidArgumentCount.
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		argument: 2.
	self deny: (send value: 3).
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		arguments: #(2 3 ).
	self 
		should: [ send value: 4 ]
		raise: GRInvalidArgumentCount! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:24'!
testValueWithArgumentUnary
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #negated.
	self 
		should: [ send value: 2 ]
		raise: GRInvalidArgumentCount.
	send := GRDelayedSend 
		receiver: 1
		selector: #negated
		arguments: #().
	self 
		should: [ send value: 2 ]
		raise: GRInvalidArgumentCount! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:24'!
testValueWithArgumentsBinary
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #+.
	self 
		should: [ send valueWithArguments: #(2 3 ) ]
		raise: GRInvalidArgumentCount.
	send := GRDelayedSend 
		receiver: 1
		selector: #+
		argument: 2.
	self 
		should: [ send valueWithArguments: #(3 4 ) ]
		raise: GRInvalidArgumentCount! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:24'!
testValueWithArgumentsKeyword
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:.
	self deny: (send valueWithArguments: #(2 3 )).
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		argument: 2.
	self 
		should: [ send valueWithArguments: #(3 4 ) ]
		raise: GRInvalidArgumentCount.
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		arguments: #(2 3 ).
	self 
		should: [ send valueWithArguments: #(4 5 ) ]
		raise: GRInvalidArgumentCount! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:24'!
testValueWithArgumentsUnary
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #negated.
	self 
		should: [ send valueWithArguments: #(2 3 ) ]
		raise: GRInvalidArgumentCount.
	send := GRDelayedSend 
		receiver: 1
		selector: #negated
		arguments: #().
	self 
		should: [ send valueWithArguments: #(2 3 ) ]
		raise: GRInvalidArgumentCount! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:24'!
testValueWithPossibleArgumentsBinary
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #+.
	self 
		should: [ send valueWithPossibleArguments: #() ]
		raise: GRInvalidArgumentCount.
	send := GRDelayedSend 
		receiver: 1
		selector: #+
		argument: 2.
	self assert: (send valueWithPossibleArguments: #()) = 3.
	send := GRDelayedSend 
		receiver: 1
		selector: #+.
	self assert: (send valueWithPossibleArguments: #(2 )) = 3.
	send := GRDelayedSend 
		receiver: 1
		selector: #+
		argument: 2.
	self assert: (send valueWithPossibleArguments: #(3 )) = 3.
	send := GRDelayedSend 
		receiver: 1
		selector: #+.
	self assert: (send valueWithPossibleArguments: #(2 3 )) = 3.
	send := GRDelayedSend 
		receiver: 1
		selector: #+
		argument: 2.
	self assert: (send valueWithPossibleArguments: #(3 4 )) = 3! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:24'!
testValueWithPossibleArgumentsKeyword
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:.
	self 
		should: [ send valueWithPossibleArguments: #() ]
		raise: GRInvalidArgumentCount.
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		argument: 2.
	self 
		should: [ send valueWithPossibleArguments: #() ]
		raise: GRInvalidArgumentCount.
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		arguments: (Array 
				with: 2
				with: 3).
	self deny: (send valueWithPossibleArguments: #()).
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:.
	self 
		should: [ send valueWithPossibleArguments: #(2 ) ]
		raise: GRInvalidArgumentCount.
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		argument: 2.
	self deny: (send valueWithPossibleArguments: #(3 )).
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		arguments: (Array 
				with: 2
				with: 3).
	self deny: (send valueWithPossibleArguments: #(4 )).
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:.
	self deny: (send valueWithPossibleArguments: #(2 3 )).
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		argument: 2.
	self deny: (send valueWithPossibleArguments: #(3 4 )).
	send := GRDelayedSend 
		receiver: 1
		selector: #between:and:
		arguments: (Array 
				with: 2
				with: 3).
	self deny: (send valueWithPossibleArguments: #(4 5 ))! !

!GRDelayedSendTest methodsFor: 'testing-evaluating' stamp: 'jf 9/30/2009 00:22'!
testValueWithPossibleArgumentsUnary
	| send |
	send := GRDelayedSend 
		receiver: 1
		selector: #negated.
	self assert: (send valueWithPossibleArguments: #()) = -1.
	send := GRDelayedSend 
		receiver: 1
		selector: #negated
		arguments: #().
	self assert: (send valueWithPossibleArguments: #()) = -1.
	send := GRDelayedSend 
		receiver: 1
		selector: #negated.
	self assert: (send valueWithPossibleArguments: #(2 )) = -1.
	send := GRDelayedSend 
		receiver: 1
		selector: #negated
		arguments: #().
	self assert: (send valueWithPossibleArguments: #(2 )) = -1.
	send := GRDelayedSend 
		receiver: 1
		selector: #negated.
	self assert: (send valueWithPossibleArguments: #(2 3 )) = -1.
	send := GRDelayedSend 
		receiver: 1
		selector: #negated
		arguments: #().
	self assert: (send valueWithPossibleArguments: #(2 3 )) = -1! !

TestCase subclass: #GRDurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRDurationTest methodsFor: 'tests' stamp: 'jf 2/5/2010 23:39'!
testAccessors
	| duration |
	duration := Duration seconds: 356521.
	self assert: duration days = 4.
	self assert: duration hours = 3.
	self assert: duration minutes = 2.
	self assert: duration seconds = 1.
	self assert: duration milliseconds = 0.! !

!GRDurationTest methodsFor: 'tests' stamp: 'jf 2/5/2010 23:54'!
testBasicInstanceCreation
	self assert: (Duration days: 1 hours: 1 minutes: 1 seconds: 1) asMilliseconds = 90061000.
	self assert: (Duration weeks: 1) asMilliseconds = 604800000.
	self assert: (Duration days: 1) asMilliseconds = 86400000.
	self assert: (Duration hours: 1) asMilliseconds = 3600000.
	self assert: (Duration minutes: 1) asMilliseconds = 60000.
	self assert: (Duration seconds: 1) asMilliseconds = 1000.
	self assert: (Duration milliseconds: 1) asMilliseconds = 1.! !

!GRDurationTest methodsFor: 'tests' stamp: 'jf 2/5/2010 23:46'!
testConversions
	| duration |
	duration := Duration days: 4 hours: 3 minutes: 2 seconds: 1.
	self assert: duration asSeconds = 356521.
	self assert: duration asMilliseconds = 356521000.
	self assert: duration negated asSeconds = -356521.
	self assert: duration negated asMilliseconds = -356521000.
	! !

!GRDurationTest methodsFor: 'testing' stamp: 'jf 2/5/2010 23:43'!
testIntegerConvenienceMethods
	self assert: 5 weeks = (Duration weeks: 5).
	self assert: 5 days = (Duration days: 5).
	self assert: 5 hours = (Duration hours: 5).
	self assert: 5 minutes = (Duration minutes: 5).
	self assert: 5 seconds = (Duration seconds: 5).
	self assert: 5 milliseconds = (Duration milliseconds: 5).! !

!GRDurationTest methodsFor: 'tests' stamp: 'jf 2/5/2010 23:57'!
testMixedInstanceCreation
	self assert: (Duration days: 1 hours: -23 minutes: 1 seconds: -59) asMilliseconds = 3601000.
! !

!GRDurationTest methodsFor: 'tests' stamp: 'jf 2/5/2010 23:56'!
testNegativeInstanceCreation
	self assert: (Duration days: -1 hours: -1 minutes: -1 seconds: -1) asMilliseconds = -90061000.
	self assert: (Duration weeks: -1) asMilliseconds = -604800000.
	self assert: (Duration days: -1) asMilliseconds = -86400000.
	self assert: (Duration hours: -1) asMilliseconds = -3600000.
	self assert: (Duration minutes: -1) asMilliseconds = -60000.
	self assert: (Duration seconds: -1) asMilliseconds = -1000.
	self assert: (Duration milliseconds: -1) asMilliseconds = -1.! !

!GRDurationTest methodsFor: 'tests' stamp: 'jf 2/6/2010 00:10'!
testPartialSecondsInstanceCreation
	"ANSI 5.8.3.1 and 5.8.3.2 specify that the seconds argument can be any
	Number - not just an integer as is the case for the other arguments."
	self assert: (Duration days: 0 hours: 0 minutes: 0 seconds: 1.5) asMilliseconds = 1500.
	self assert: (Duration days: 0 hours: 0 minutes: 0 seconds: 3/2) asMilliseconds = 1500.
	self assert: (Duration seconds: 1.5) asMilliseconds = 1500.
	self assert: (Duration seconds: 3/2) asMilliseconds = 1500.! !

!GRDurationTest methodsFor: 'tests' stamp: 'jf 2/6/2010 00:09'!
testRolloverInstanceCreation
	self assert: (Duration days: 0 hours: 25 minutes: 61 seconds: 61) asMilliseconds = 93721000.
	self assert: (Duration hours: 25) asMilliseconds = 90000000.
	self assert: (Duration minutes: 61) asMilliseconds = 3660000.
	self assert: (Duration seconds: 61) asMilliseconds = 61000.
	self assert: (Duration milliseconds: 1001) asMilliseconds = 1001.! !

!GRDurationTest methodsFor: 'tests' stamp: 'jf 2/5/2010 23:47'!
testZero
	| duration |
	duration := Duration zero.
	self assert: duration isZero.
	self assert: duration asMilliseconds = 0.
	self assert: duration = (Duration seconds: 0)! !

TestCase subclass: #GRExceptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRExceptionTest methodsFor: 'private' stamp: 'dkh 11/13/2009 11:19'!
onExceptionReturn: anObject
	[ GRError signal ]
		on: GRError
		do: [:ex | ^ anObject ].
	
	^ self! !

!GRExceptionTest methodsFor: 'tests' stamp: 'jf 11/3/2009 00:48'!
testDefaultActionResume
	"According to ANSI 5.5.15.2, the result of #defaultAction
	should be used to resume resumable exceptions. Behaviour is undefined
	for non-resumable exceptions so we do not test for that case."
	
	| result |
	result := GRNotificationStub signal.
	self assert: result = #returnValue.! !

!GRExceptionTest methodsFor: 'tests' stamp: 'lr 1/25/2010 23:31'!
testDeprecatedApi
	| exception seen |
	exception := seen := nil.
	
	[ self 
		greaseDeprecatedApi: 'GRExceptionTest>>#testDeprecatedApi'
		details: 'Message in a bottle.'.
	seen := true ] 
		on: GRDeprecatedApiNotification
		do: 
			[ :notification | 
			exception := notification.
			exception resume.
			seen := false ].
	self assert: seen.
	self assert: exception notNil.
	self assert: exception messageText = 'GRExceptionTest>>#testDeprecatedApi'.
	self assert: exception details = 'Message in a bottle.'! !

!GRExceptionTest methodsFor: 'tests' stamp: 'jf 9/30/2009 00:56'!
testErrorInitialization
	"Make sure #initialize is called on #new and that calling 'super initialize' doesn't error."
	self assert: GRErrorStub new foo! !

!GRExceptionTest methodsFor: 'tests' stamp: 'jf 11/3/2009 00:39'!
testIsResumable
	"Make sure the platform class provides #isResumable on Exception.
	This test made a bit more complex by James Foster per issue #259
	for GemStone portability."

	| exception |
	[ Exception signal ]
		on: Exception
		do: [ :ex | 
			exception := ex.
			ex return
	].
	self shouldnt: [ exception isResumable ] raise: MessageNotUnderstood! !

!GRExceptionTest methodsFor: 'tests' stamp: 'jf 9/30/2009 00:57'!
testNotificationInitialization
	"Make sure #initialize is called on #new and that calling 'super initialize' doesn't error."
	self assert: GRNotificationStub new foo! !

!GRExceptionTest methodsFor: 'tests' stamp: 'jf 11/3/2009 00:44'!
testOnDoImplicitReturn
	"According to ANSI 5.5.15.2, an exception handler block that runs to completion
	should result in the call to #on:do: returning the block's value."
	
	| result |
	result := [ GRErrorStub signal ] on: GRErrorStub do: [ :e | #blockValue ].
	self assert: result = #blockValue.
	
	result := nil.
	result := [ GRNotificationStub signal ] on: GRNotificationStub do: [ :e | #blockValue ].
	self assert: result = #blockValue.! !

!GRExceptionTest methodsFor: 'tests' stamp: 'jf 11/3/2009 00:53'!
testOnDoNonLocalReturn
	"You should be able to do a non-local return from within an exception
	handler block. We rely on a helper method here so we can check the return
	value."
	
	self assert: (self onExceptionReturn: 123) == 123! !

!GRExceptionTest methodsFor: 'tests' stamp: 'jf 11/3/2009 00:39'!
testSignalError
	"Exception>>signal is part of the ANSI Smalltalk standard. However, Seaside
	only signals subclasses of WAPlatformError and WAPlatformNotification so Smalltalk
	implementations that do not otherwise provide it can implement it on
	these two classes."
	[ GRError new signal ] 
		on: GRError
		do: [ :e | ^ self ].
	self assert: false! !

!GRExceptionTest methodsFor: 'tests' stamp: 'jf 11/3/2009 00:39'!
testSignalErrorClassSide
	"Exception class>>signal is part of the ANSI Smalltalk standard. However, Seaside
	only signals subclasses of WAPlatformError and WAPlatformNotification so Smalltalk
	implementations that do not otherwise provide it can implement it on
	these two classes."
	[ GRError signal ] 
		on: GRError
		do: [ :e | ^ self ].
	self assert: false! !

!GRExceptionTest methodsFor: 'tests' stamp: 'jf 11/3/2009 00:39'!
testSignalNotification
	"Exception>>signal is part of the ANSI Smalltalk standard. However, Seaside
	only signals subclasses of WAPlatformError and WAPlatformNotification so Smalltalk
	implementations that do not otherwise provide it can implement it on
	these two classes."
	[ GRNotification new signal ] 
		on: GRNotification
		do: [ :e | ^ self ].
	self assert: false! !

!GRExceptionTest methodsFor: 'tests' stamp: 'jf 11/3/2009 00:39'!
testSignalNotificationClassSide
	"Exception class>>signal is part of the ANSI Smalltalk standard. However, Seaside
	only signals subclasses of WAPlatformError and WAPlatformNotification so Smalltalk
	implementations that do not otherwise provide it can implement it on
	these two classes."
	[ GRNotification signal ] 
		on: GRNotification
		do: [ :e | ^ self ].
	self assert: false! !

!GRExceptionTest methodsFor: 'tests' stamp: 'jf 11/3/2009 00:39'!
testSignalWithError
	"Exception>>signal: is part of the ANSI Smalltalk standard. However, Seaside
	only signals subclasses of WAPlatformError and WAPlatformNotification so Smalltalk
	implementations that do not otherwise provide it can implement it on
	these two classes."
	| text |
	text := 'Error!!'.
	[ GRError new signal: text ] 
		on: GRError
		do: 
			[ :e | 
			self assert: e messageText = text.
			^ self ].
	self assert: false! !

!GRExceptionTest methodsFor: 'tests' stamp: 'jf 11/3/2009 00:39'!
testSignalWithErrorClassSide
	"Exception class>>signal: is part of the ANSI Smalltalk standard. However, Seaside
	only signals subclasses of WAPlatformError and WAPlatformNotification so Smalltalk
	implementations that do not otherwise provide it can implement it on
	these two classes."
	| text |
	text := 'Error!!'.
	[ GRError signal: text ] 
		on: GRError
		do: 
			[ :e | 
			self assert: e messageText = text.
			^ self ].
	self assert: false! !

!GRExceptionTest methodsFor: 'tests' stamp: 'jf 11/3/2009 00:39'!
testSignalWithNotification
	"Exception>>signal: is part of the ANSI Smalltalk standard. However, Seaside
	only signals subclasses of WAPlatformError and WAPlatformNotification so Smalltalk
	implementations that do not otherwise provide it can implement it on
	these two classes."
	| text |
	text := 'Notification'.
	[ GRNotification new signal: text ] 
		on: GRNotification
		do: 
			[ :e | 
			self assert: e messageText = text.
			^ self ].
	self assert: false! !

!GRExceptionTest methodsFor: 'tests' stamp: 'jf 11/3/2009 00:39'!
testSignalWithNotificationClassSide
	"Exception class>>signal: is part of the ANSI Smalltalk standard. However, Seaside
	only signals subclasses of WAPlatformError and WAPlatformNotification so Smalltalk
	implementations that do not otherwise provide it can implement it on
	these two classes."
	| text |
	text := 'Notification'.
	[ GRNotification signal: text ] 
		on: GRNotification
		do: 
			[ :e | 
			self assert: e messageText = text.
			^ self ].
	self assert: false! !

TestCase subclass: #GRNullCodecStreamTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRNullCodecStreamTest methodsFor: 'accessing' stamp: 'lr 2/6/2010 10:30'!
codecStreamClass
	^ GRNullCodecStream! !

!GRNullCodecStreamTest methodsFor: 'testing-characters' stamp: 'lr 2/6/2010 10:34'!
testCrlf
	| stream |
	stream := GRNullCodec new 
		encoderFor: (WriteStream on: String new).
	stream crlf.
	
	self assert: stream contents size = 2.
	self assert: stream contents first = Character cr.
	self assert: stream contents last = Character lf! !

!GRNullCodecStreamTest methodsFor: 'testing-protocol' stamp: 'lr 2/6/2010 10:37'!
testFlush
	| stream |
	stream := GRNullCodec new 
		encoderFor: (WriteStream on: String new).
	stream nextPutAll: 'abc'.
	self shouldnt: [ stream flush ] raise: Error.
	self assert: stream contents = 'abc'! !

!GRNullCodecStreamTest methodsFor: 'testing' stamp: 'dkh 11/13/2009 15:36'!
testReadString
	| stream codecStream |
	stream := 'abc' readStream.
	codecStream := GRNullCodec new decoderFor: stream.
	self assert: codecStream next = $a.
	self assert: (codecStream next: 2) = 'bc'! !

!GRNullCodecStreamTest methodsFor: 'testing-protocol' stamp: 'lr 2/6/2010 10:37'!
testSize
	| stream |
	stream := GRNullCodec new 
		encoderFor: (WriteStream on: String new).
	stream nextPutAll: 'abc'.
	self assert: stream size = 3.
	stream nextPut: $d.
	self assert: stream size = 4! !

!GRNullCodecStreamTest methodsFor: 'testing-characters' stamp: 'lr 2/6/2010 10:34'!
testSpace
	| stream |
	stream := GRNullCodec new 
		encoderFor: (WriteStream on: String new).
	stream space.
	
	self assert: stream contents size = 1.
	self assert: stream contents first = Character space! !

!GRNullCodecStreamTest methodsFor: 'testing-characters' stamp: 'lr 2/6/2010 10:35'!
testTab
	| stream |
	stream := GRNullCodec new 
		encoderFor: (WriteStream on: String new).
	stream tab.
	
	self assert: stream contents size = 1.
	self assert: stream contents first = Character tab! !

!GRNullCodecStreamTest methodsFor: 'testing-protocol' stamp: 'lr 2/6/2010 10:37'!
testText
	| stream |
	stream := GRNullCodec new 
		encoderFor: (WriteStream on: String new).
	self shouldnt: [ stream text ] raise: Error! !

!GRNullCodecStreamTest methodsFor: 'testing' stamp: 'dkh 11/13/2009 15:36'!
testWriteString
	| stream codecStream |
	stream := WriteStream on: String new.
	codecStream := GRNullCodec new encoderFor: stream.
	codecStream
		nextPut: $A;
		nextPutAll: 'BC';
		nextPut: 68;
		nextPutAll: #(69 70 ) asByteArray.
	self assert: codecStream contents = 'ABCDEF'! !

TestCase subclass: #GRNumberTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRNumberTest methodsFor: 'testing' stamp: 'jf 9/25/2009 16:50'!
testBetweenAnd
	self assert: (6 between: 1 and: 12)! !

!GRNumberTest methodsFor: 'testing' stamp: 'pmm 2/24/2008 18:33'!
testPluralize
	self assert: (0 pluralize: 'person') = '0 people'.
	self assert: (1 pluralize: 'person') = '1 person'.
	self assert: (2 pluralize: 'person') = '2 people'.
	self assert: (3 pluralize: 'person') = '3 people'.
	
	self assert: (0 pluralize: 'penis') = '0 penises'.
	self assert: (1 pluralize: 'penis') = '1 penis'.
	self assert: (2 pluralize: 'penis') = '2 penises'.
	
	self assert: (0 pluralize: 'person' with: 'members') = '0 members'.
	self assert: (1 pluralize: 'person' with: 'members') = '1 person'.
	self assert: (2 pluralize: 'person' with: 'members') = '2 members'.
	self assert: (3 pluralize: 'person' with: 'members') = '3 members'! !

!GRNumberTest methodsFor: 'testing' stamp: 'yann.monclair 9/4/2009 16:16'!
testReadFrom
	"We test #readFrom: as the expected behaviour on all platforms, as we rely on it for WANumberAttribute and WAQualifiedValue"
	
	self assert: (Number readFrom: '123' readStream) = 123 .
	
	self assert: (Float readFrom: '123.45' readStream) = 123.45 .
	
	self assert:   (Number readFrom: '123.45' readStream) = 123.45 .
	
	"this final test may not be correct. This is the expected behaviour in Pharo. VisualWorks & GemStone64"
	self assert: (Number readFrom: 'seaside' readStream) = 0 .
	self assert: (Float readFrom: 'seaside' readStream) = 0.0 . 
	  ! !

!GRNumberTest methodsFor: 'testing' stamp: 'jf 9/25/2009 15:31'!
testTo
	| collection |
	collection := OrderedCollection new.
	(1 to: 5) do: [ :ea | collection add: ea ].
	self assert: collection asArray = #(1 2 3 4 5).
	
	collection := OrderedCollection new.
	(4 to: 4) do: [ :ea | collection add: ea ].
	self assert: collection asArray = #(4).
	
	collection := OrderedCollection new.
	(4 to: 4) do: [ :ea | collection add: ea ].
	self assert: collection asArray = #(4).
	
	collection := OrderedCollection new.
	(5 to: 4) do: [ :ea | collection add: ea ].
	self assert: collection asArray = #().
	
	collection := OrderedCollection new.
	(-3 to: -1.5) do: [ :ea | collection add: ea ].
	self assert: collection asArray = #(-3 -2).
	
	collection := OrderedCollection new.
	(1.5 to: 4) do: [ :ea | collection add: ea ].
	self assert: collection asArray = #(1.5 2.5 3.5).! !

!GRNumberTest methodsFor: 'testing' stamp: 'jf 9/25/2009 15:29'!
testToDo
	| collection |
	collection := OrderedCollection new.
	1 to: 5 do: [ :ea | collection add: ea ].
	self assert: collection asArray = #(1 2 3 4 5).
	
	collection := OrderedCollection new.
	4 to: 4 do: [ :ea | collection add: ea ].
	self assert: collection asArray = #(4).
	
	collection := OrderedCollection new.
	4 to: 4 do: [ :ea | collection add: ea ].
	self assert: collection asArray = #(4).
	
	collection := OrderedCollection new.
	5 to: 4 do: [ :ea | collection add: ea ].
	self assert: collection asArray = #().
	
	collection := OrderedCollection new.
	-3 to: -1.5 do: [ :ea | collection add: ea ].
	self assert: collection asArray = #(-3 -2).
	
	collection := OrderedCollection new.
	1.5 to: 4 do: [ :ea | collection add: ea ].
	self assert: collection asArray = #(1.5 2.5 3.5).! !

!GRNumberTest methodsFor: 'testing' stamp: 'jf 9/25/2009 15:25'!
testToDoClosures
	"#to:do: may be optimized and VAST currently has problems with closures
	in this case. We would prefer to use the optimized version than than
	(1 to: 5) do: [ ... ] so this test is here to hilight the problem at
	least unless the platforms tell us the problem is not fixable."
	
	| collection |
	collection := OrderedCollection new.
	1 to: 5 do: [ :ea | collection add: [ea] fixCallbackTemps ].
	self assert: (collection collect: [ :ea | ea value ]) asArray = #(1 2 3 4 5)! !

TestCase subclass: #GRObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRObjectTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:20'!
testError
	"Make sure #error: signals a subclass of WAPlatformError."
	self 
		should: [ GRObject new error: 'oh dear' ]
		raise: GRError.
	self 
		should: [ GRObject error: 'oh dear' ]
		raise: GRError! !

!GRObjectTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:56'!
testInitialize
	"Make sure #initialize is called on #new and that calling 'super initialize' doesn't error."
	self assert: GRObjectStub new foo! !

TestCase subclass: #GRPackageTest
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRPackageTest methodsFor: 'running' stamp: 'lr 2/6/2010 10:44'!
setUp
	super setUp.
	package := GRPackage new! !

!GRPackageTest methodsFor: 'testing-dependencies' stamp: 'lr 2/6/2010 10:55'!
testAllDependencies
	| packages |
	packages := Dictionary new.
	packages 
		at: 'Lust' put: (GRPackage new
			name: 'Lust';
			addDependency: 'Gluttony';
			addDependency: 'Greed';
			yourself);
		at: 'Gluttony' put: (GRPackage new
			name: 'Gluttony';
			addDependency: 'Greed';
			yourself);
		at: 'Greed' put: (GRPackage new
			name: 'Greed';
			yourself).
	packages values 
		do: [ :each | each resolveWith: packages ].
	
	self assert: (packages at: 'Lust') allDependencies size = 3.
	self assert: (packages at: 'Gluttony') allDependencies size = 2.
	self assert: (packages at: 'Greed') allDependencies size = 1.! !

!GRPackageTest methodsFor: 'testing-dependencies' stamp: 'lr 2/6/2010 10:47'!
testDependencies
	self assert: package dependencies isEmpty.
	package addDependency: 'Lust'.
	package addDependency: 'Envy'.
	self assert: package dependencies size = 2.
	self assert: package dependencies first = 'Lust'.
	self assert: package dependencies last = 'Envy'
	! !

!GRPackageTest methodsFor: 'testing' stamp: 'lr 2/6/2010 10:44'!
testDescription
	self assert: package description isNil.
	package description: 'A hopeless pacakge'.
	self assert: package description = 'A hopeless pacakge'! !

!GRPackageTest methodsFor: 'testing' stamp: 'lr 2/6/2010 10:58'!
testLicense
	self assert: package license = #MIT.
	self assert: package isMIT.
	
	package license: #LGPL.
	self assert: package license = #LGPL.
	self assert: package isLGPL! !

!GRPackageTest methodsFor: 'testing' stamp: 'lr 2/6/2010 10:44'!
testName
	self assert: package name isNil.
	package name: 'Gimme-Hope'.
	self assert: package name = 'Gimme-Hope'! !

!GRPackageTest methodsFor: 'testing-packages' stamp: 'lr 2/6/2010 10:57'!
testPackages
	| packages |
	packages := GRPackage packages.
	self assert: packages notEmpty.
	packages 
		do: [ :each | self assert: each name notEmpty ]! !

TestCase subclass: #GRPlatformTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRPlatformTest commentStamp: 'pmm 9/15/2007 08:57' prior: 0!
A WAPlatformTest is a test to make sure the platform (= the Smalltalk dialect we are running on) implements the protocol we need for system classes like Collection. An example would be to make sure Collection implements #count: with the sementics we need.!

!GRPlatformTest methodsFor: 'private' stamp: 'jf 9/30/2009 00:27'!
decodeUtf8Character: aCollectionOfIntegers 
	"Decodes a collection of bytes into a single character. We have this so we can avoid having non-ASCII characters in the source."
	| codec toDecode decoded |
	codec := GRCodec forEncoding: 'utf-8'.
	toDecode := String streamContents: 
		[ :stream | 
		aCollectionOfIntegers do: [ :each | stream nextPut: (Character codePoint: each) ] ].
	decoded := codec decode: toDecode.
	self assert: decoded size = 1.
	^ decoded at: 1! !

!GRPlatformTest methodsFor: 'accessing' stamp: 'jf 9/30/2009 00:19'!
platform
	^ GRPlatform current! !

!GRPlatformTest methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
testAsNumber
	self assert: 2007 asNumber = 2007.
	self assert: '2007' asNumber = 2007! !

!GRPlatformTest methodsFor: 'testing' stamp: 'pmm 3/22/2008 12:33'!
testAsSeconds
	| duration |
	duration := Duration days: 1 hours: 0 minutes: 0 seconds: 0.
	self assert: duration asSeconds = 86400! !

!GRPlatformTest methodsFor: 'testing' stamp: 'pmm 1/10/2009 23:41'!
testBlockContextWithPossibleArguments
	| block |
	block := [ :x | 1 + x ].
	self assert: (block valueWithPossibleArguments: (Array with: 2)) = 3.

	block := [ false not ].
	self assert: (block valueWithPossibleArguments: (Array with: 3))! !

!GRPlatformTest methodsFor: 'testing' stamp: 'jf 12/18/2009 12:26'!
testBlockValuableProtocol
	self assert: [ nil ] argumentCount isZero.
	self assert: [ :x | x ] argumentCount = 1.
	self assert: [ :a :b | a + b ] argumentCount = 2.
	self 
		shouldnt: [ [ nil ] fixCallbackTemps ]
		raise: Error.
	self 
		shouldnt: [ [ :x | x ] fixCallbackTemps ]
		raise: Error.
	self 
		shouldnt: [ [ :a :b | a + b ] fixCallbackTemps ]
		raise: Error! !

!GRPlatformTest methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
testCharacterAsUnicode
	"test for:
	Character >> #asUnicode
		^self asInteger"
	self assert: $S asUnicode = 83! !

!GRPlatformTest methodsFor: 'testing' stamp: 'lr 1/23/2010 13:29'!
testCharacterTo
	| actual expected |
	actual := Array withAll: 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_-'.
	actual := actual collect: [ :each | each greaseInteger ].
	expected := #(
		97
		98
		99
		100
		101
		102
		103
		104
		105
		106
		107
		108
		109
		110
		111
		112
		113
		114
		115
		116
		117
		118
		119
		120
		121
		122
		65
		66
		67
		68
		69
		70
		71
		72
		73
		74
		75
		76
		77
		78
		79
		80
		81
		82
		83
		84
		85
		86
		87
		88
		89
		90
		48
		49
		50
		51
		52
		53
		54
		55
		56
		57
		95
		45
	).
	self assert: actual size = expected size.
	actual 
		with: expected
		do: [ :first :second | self assert: first = second ]! !

!GRPlatformTest methodsFor: 'testing' stamp: 'pmm 9/13/2008 14:36'!
testDateArithmetic
	| today tomorrow oneDay minusOneDay |
	today := DateAndTime year: 2008 month: 9 day: 13 hour: 14 minute: 32 second: 05 offset: Duration zero.
	tomorrow := DateAndTime year: 2008 month: 9 day: 14 hour: 14 minute: 32 second: 05 offset: Duration zero.
	oneDay := Duration days: 1 hours: 0 minutes: 0 seconds: 0.
	minusOneDay := Duration days: -1 hours: 0 minutes: 0 seconds: 0.
	self assert: tomorrow - today = oneDay.
	self assert: today - tomorrow = minusOneDay.
	self assert: today + oneDay = tomorrow.
	self assert: tomorrow - oneDay = today.
	self assert: tomorrow + minusOneDay = today.
	self assert: today - minusOneDay = tomorrow! !

!GRPlatformTest methodsFor: 'testing' stamp: 'jf 12/18/2009 10:30'!
testDaysInMonthForYear
	(1 to: 12) with: #(31 28 31 30 31 30 31 31 30 31 30 31) do: [ :month :days |
		self assert: days = (Date daysInMonth: (Date nameOfMonth: month) forYear: 2007) ]! !

!GRPlatformTest methodsFor: 'testing' stamp: 'lr 1/23/2010 13:28'!
testDigitValue
	'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ' 
		with: (0 to: 35)
		do: [ :each :expected | self assert: each digitValue = expected ]! !

!GRPlatformTest methodsFor: 'testing' stamp: 'pmm 10/2/2007 06:54'!
testEmptyOrNil
	self assert: '' isEmptyOrNil.
	self assert: nil isEmptyOrNil.
	self assert: Array new isEmptyOrNil.
	self deny: 'Timberwolf' isEmptyOrNil! !

!GRPlatformTest methodsFor: 'testing' stamp: 'lr 10/28/2007 14:42'!
testFixCallbackTemps
	"Make sure that #fixCallbackTemps is properly understood by block-contexts. Make sure that this is either a nop for Smalltalks with true block closures, or it properly fixes the context otherwise."

	| array blocks values |
	array := #(1 2 3).
	blocks := array collect: [ :each | [ each ] fixCallbackTemps ].
	values := blocks collect: [ :each | each value ].
	self assert: values = array! !

!GRPlatformTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:07'!
testGreaseIntegerOnCharacter
	"ASCII (1 byte)"
	| oWithStroke euro manna |
	self assert: $a greaseInteger = 97.
	self assert: $A greaseInteger = 65.

	"Latin-1 (2 byte)"
	oWithStroke := self decodeUtf8Character: #(195 152 ).
	self assert: oWithStroke greaseInteger = 216.

	"BMP (3 byte)"
	euro := self decodeUtf8Character: #(226 130 172 ).
	self assert: euro greaseInteger = 8364.

	"SMP (4 byte)"
	manna := self decodeUtf8Character: #(240 144 140 188 ).
	self assert: manna greaseInteger = 66364! !

!GRPlatformTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:07'!
testGreaseIntegerOnNumber
	self assert: 2007 greaseInteger = 2007.
	self assert: 2007.0 greaseInteger = 2007.
	self assert: 2007.1 greaseInteger = 2007.
	self assert: 2007.9 greaseInteger = 2007! !

!GRPlatformTest methodsFor: 'testing' stamp: 'jf 9/30/2009 01:08'!
testGreaseIntegerOnString
	self assert: '' greaseInteger isNil.
	self assert: 'a' greaseInteger isNil.
	self assert: ' 1' greaseInteger isNil.
	self assert: 'a1' greaseInteger isNil.
	self assert: '-' greaseInteger isNil.
	self assert: '-a' greaseInteger isNil.
	self assert: '0' greaseInteger = 0.
	self assert: '12' greaseInteger = 12.
	self assert: '123' greaseInteger = 123.
	self assert: '123456789' greaseInteger = 123456789.
	self assert: '-0' greaseInteger = 0.
	self assert: '-12' greaseInteger = -12.
	self assert: '-123.4' greaseInteger = -123.
	self assert: '-123456789' greaseInteger = -123456789! !

!GRPlatformTest methodsFor: 'testing' stamp: 'jf 12/7/2009 21:30'!
testGreaseString
	self assert: 'Timberwolf' greaseString = 'Timberwolf'.
	self assert: #DireWolf greaseString = 'DireWolf'.
	self assert: true greaseString = 'true'.
	self assert: 666 greaseString = '666'.
	self assert: $A greaseString = 'A'.
	self assert: nil greaseString = 'nil'.
	[ 1 / 0 ] 
		on: ZeroDivide
		do: [ :error | self assert: error greaseString isString ].
	self assert: 15.25 greaseString = '15.25'.
	self assert: nil greaseString isString.
	self assert: (4 @ 2) greaseString = '4@2'.
	"#seasideString for a byte array should not do any decoding
	this is in place to catch encoding errors early"
	self assert: #(101 97 ) asByteArray greaseString ~= 'ea'.
	self assert: #(101 97 ) asByteArray greaseString isString.
	self assert: Object new greaseString isString! !

!GRPlatformTest methodsFor: 'testing' stamp: 'pmm 11/10/2007 17:19'!
testIfNil
	self assert: (nil ifNil: [ 1 ]) = 1.
	self assert: (1 ifNil: [ 2 ]) = 1! !

!GRPlatformTest methodsFor: 'testing' stamp: 'lr 12/3/2009 10:54'!
testIfTrueIfFalse
	self assert: (false ifFalse: [ #false ]) = #false.
	self assert: (false ifTrue: [ #true ]) isNil.
	self assert: (true ifTrue: [ #true ]) = #true.
	self assert: (true ifFalse: [ #false ]) isNil.
	self assert: (true ifTrue: [ #true ] ifFalse: [ #false ]) = #true.
	self assert: (false ifTrue: [ #true ] ifFalse: [ #false ]) = #false.
	self assert: (true ifFalse: [ #false ] ifTrue: [ #true ]) = #true.
	self assert: (false ifFalse: [ #false ] ifTrue: [ #true ]) = #false! !

!GRPlatformTest methodsFor: 'testing' stamp: 'pmm 5/2/2009 17:18'!
testIsCharacter
	self deny: 7 isCharacter.
	self assert: $7 isCharacter! !

!GRPlatformTest methodsFor: 'testing' stamp: 'dkh 3/7/2008 10:15'!
testIsCollection
	self deny: Object new isCollection.
	self assert: #(1 2 3 4) isCollection.
	self assert: #(1 2 3 4) asOrderedCollection isCollection.
	self assert: Dictionary new isCollection.! !

!GRPlatformTest methodsFor: 'testing' stamp: 'pmm 2/14/2008 20:42'!
testIsKeyword
	self deny: #isKeyword isKeyword.
	self deny: #+ isKeyword.
	self assert: #isKeyword: isKeyword.
	self assert: #isKeyword:isKeyword: isKeyword.! !

!GRPlatformTest methodsFor: 'testing' stamp: 'pmm 2/14/2008 20:42'!
testIsUnary
	self assert: #isUnary isUnary.
	self deny: #+ isUnary.
	self deny: #isUnary: isUnary.
	self deny: #isUnary:isUnary: isUnary.! !

!GRPlatformTest methodsFor: 'testing' stamp: 'pmm 1/10/2009 22:23'!
testNumArgs
	self assert: #not numArgs isZero.
	self assert: #+ numArgs = 1.
	self assert: #and: numArgs = 1.
	self assert: #value:value: numArgs = 2! !

!GRPlatformTest methodsFor: 'testing' stamp: 'jok 4/2/2009 09:21'!
testPrintStringLimitedTo

	| longString shortString |
	longString := String streamContents: [:stream |
		1 to: 1000 do: [:i | stream nextPutAll: i printString]].
	"Squeak implementation adds 9 characters to limited string and VA Smalltalk adds 10, so we can't do an exact count."
	self assert: longString printString size > 65.
	shortString := longString printStringLimitedTo: 50.
	self assert: shortString size < 65! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 9/25/2009 16:19'!
testRandomGenerator
	| generator collection |
	generator := self platform newRandom.
	self should: [ generator nextInt: 0 ] raise: Error.
	self assert: (generator nextInt: 1) = 1.
	collection := (1 to: 200) collect: [ :ea | generator nextInt: 2 ].
	self assert: (collection includes: 1).
	self assert: (collection includes: 2).
	self assert: collection asSet size = 2.

	collection := 1 to: 5.
	self assert: (collection includes: (generator randomFrom: collection)).
	collection := -1.5 to: 3.5.
	self assert: (collection includes: (generator randomFrom: collection)).
	collection := #(1 2 3 4 5).
	self assert: (collection includes: (generator randomFrom: collection)).
	collection := #(1 2 3 4 5) asSet.
	self assert: (collection includes: (generator randomFrom: collection)).! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'lr 1/22/2009 22:01'!
testReadStreamAtEnd
	"ANSI 5.9.2.1"
	
	| stream |
	stream := '' readStream.
	self assert: stream atEnd.

	stream := 'a' readStream.
	self deny: stream atEnd! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'lr 1/22/2009 22:06'!
testReadStreamContents
	"ANSI 5.9.3.1"
	
	| stream |
	stream := 'abc' readStream.
	self assert: stream contents = 'abc'.
	stream next: 2.
	self assert: stream contents = 'abc'! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 9/14/2009 13:52'!
testReadStreamNegativeSkip
	"ANSI does not mention negative values being used with #skip: but we
	believe they work consistently. If not, we need to update our coding
	conventions to make sure we never do this."
	
	| stream position |
	stream := 'abcd' readStream.
	stream next; next.
	position := stream position.
	self assert: (stream peek) = $c.
	stream skip: -1.
	self assert: stream position = (position - 1).
	self assert: (stream peek) = $b! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'lr 1/22/2009 22:00'!
testReadStreamNext
	"ANSI 5.9.2.3"
	
	| stream |
	stream := 'abcd' readStream.
	self assert: stream next = $a.
	self assert: (stream next: 0) = ''.
	self assert: (stream next: 1) = 'b'.
	self assert: (stream next: 2) = 'cd'! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'lr 1/22/2009 22:00'!
testReadStreamPeek
	"ANSI 5.9.2.7"
	
	| stream |
	stream := 'abcd' readStream.
	self assert: stream peek = $a.
	
	stream := '' readStream.
	self assert: stream peek isNil! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 7/31/2009 13:40'!
testReadStreamPosition
	"ANSI 5.9.1.4 and 5.9.1.5"
	
	| stream |
	stream := 'abc' readStream.
	self assert: stream position = 0.
	stream next.
	self assert: stream position = 1.
	stream next.
	self assert: stream position = 2.
	stream next.
	self assert: stream position = 3.
	
	stream position: 1.
	self assert: stream position = 1.
	self assert: stream next = $b.
	stream position: 0.
	self assert: stream position = 0.
	self assert: stream next = $a.
	stream position: 3.
	self assert: stream atEnd
	! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'lr 1/23/2009 11:41'!
testReadStreamReset
	"ANSI 5.9.1.6"
	
	| stream |
	stream := 'abc' readStream.
	stream next: 2.
	stream reset.
	self assert: stream next = $a! !

!GRPlatformTest methodsFor: 'testing-streams-seaside' stamp: 'jf 9/30/2009 01:06'!
testReadStreamSeasideUpToAll
	| stream string1 string2 |
	stream := 'abc12def' readStream.
	string1 := stream greaseUpToAll: '12'.
	string2 := stream greaseUpToAll: '12'.
	self assert: string1 = 'abc'.
	self assert: string2 = 'def'.
	self assert: stream atEnd! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'lr 1/22/2009 22:02'!
testReadStreamSkip
	"ANSI 5.9.2.9"
	
	| stream |
	stream := 'abcd' readStream.
	self assert: (stream skip: 2; peek) = $c! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'mlucas-smith 6/3/2009 22:33'!
testReadStreamUpTo
	"ANSI 5.9.2.11"
	
	| stream |
	stream := 'abcd' readStream.
	self assert: (stream upTo: $c) = 'ab'.
	self assert: stream next = $d.
	
	stream := 'abcd' readStream.
	self assert: (stream upTo: $x) = 'abcd'.
	self assert: stream atEnd! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 7/31/2009 13:33'!
testReadStreamUpToEnd
	"Not defined by ANSI."
	
	| stream |
	stream := 'abcd' readStream.
	self assert: stream upToEnd = 'abcd'.
	self assert: stream atEnd.
	self assert: stream upToEnd = ''.
	self assert: stream atEnd.
	
	stream := 'abcd' readStream.
	stream upTo: $b.
	self assert: stream upToEnd = 'cd'.
	self assert: stream atEnd! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 9/30/2009 00:19'!
testReadWriteStreamAtEnd
	"ANSI 5.9.2.1"
	| stream |
	stream := GRPlatform current readWriteCharacterStream.
	self assert: stream atEnd.
	stream
		nextPut: $a;
		reset.
	self deny: stream atEnd! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 9/30/2009 00:19'!
testReadWriteStreamContents
	"ANSI 5.9.3.1"
	| stream |
	stream := GRPlatform current readWriteCharacterStream.
	stream
		nextPutAll: 'abc';
		reset.
	self assert: stream contents = 'abc'.
	stream next: 2.
	self assert: stream contents = 'abc'.
	stream := GRPlatform current readWriteByteStream.
	stream
		nextPutAll: 'abc' asByteArray;
		reset.
	self assert: stream contents = 'abc' asByteArray.
	stream next: 2.
	self assert: stream contents = 'abc' asByteArray! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 9/30/2009 00:19'!
testReadWriteStreamNegativeSkip
	"ANSI does not mention negative values being used with #skip: but we
	believe they work consistently. If not, we need to update our coding
	conventions to make sure we never do this."
	| stream position |
	stream := GRPlatform current readWriteCharacterStream.
	stream
		nextPutAll: 'abcd';
		reset.
	stream
		next;
		next.
	position := stream position.
	self assert: stream peek = $c.
	stream skip: -1.
	self assert: stream position = (position - 1).
	self assert: stream peek = $b.
	stream := GRPlatform current readWriteByteStream.
	stream
		nextPutAll: 'abcd' asByteArray;
		reset.
	stream
		next;
		next.
	position := stream position.
	self assert: stream peek = 99.
	stream skip: -1.
	self assert: stream position = (position - 1).
	self assert: stream peek = 98! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 9/30/2009 00:19'!
testReadWriteStreamNext
	"ANSI 5.9.2.3"
	| stream |
	stream := GRPlatform current readWriteCharacterStream.
	stream
		nextPutAll: 'abcd';
		reset.
	self assert: stream next = $a.
	self assert: (stream next: 0) = ''.
	self assert: (stream next: 1) = 'b'.
	self assert: (stream next: 2) = 'cd'.
	stream := GRPlatform current readWriteByteStream.
	stream
		nextPutAll: 'abcd' asByteArray;
		reset.
	self assert: stream next = 97.
	self assert: (stream next: 0) = '' asByteArray.
	self assert: (stream next: 1) = 'b' asByteArray.
	self assert: (stream next: 2) = 'cd' asByteArray! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 9/30/2009 00:19'!
testReadWriteStreamNextPut
	"ANSI 5.9.4.3"
	| stream |
	stream := GRPlatform current readWriteCharacterStream.
	stream nextPut: $a.
	self assert: stream contents = 'a'.
	stream := GRPlatform current readWriteByteStream.
	stream nextPut: 97.
	self assert: stream contents = 'a' asByteArray! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 9/30/2009 00:19'!
testReadWriteStreamNextPutAll
	"ANSI 5.9.4.4"
	| stream |
	stream := GRPlatform current readWriteCharacterStream.
	stream nextPutAll: 'abc'.
	self assert: stream contents = 'abc'.
	stream := GRPlatform current readWriteCharacterStream.
	stream nextPutAll: #($a $b $c ).
	self assert: stream contents = 'abc'.
	stream := GRPlatform current readWriteByteStream.
	stream nextPutAll: #(97 98 99 ) asByteArray.
	self assert: stream contents = 'abc' asByteArray! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 9/30/2009 00:19'!
testReadWriteStreamPeek
	"ANSI 5.9.2.7"
	| stream |
	stream := GRPlatform current readWriteCharacterStream.
	self assert: stream peek isNil.
	stream := GRPlatform current readWriteCharacterStream.
	stream
		nextPutAll: 'abcd';
		reset.
	self assert: stream peek = $a.
	stream := GRPlatform current readWriteByteStream.
	stream
		nextPutAll: 'abcd' asByteArray;
		reset.
	self assert: stream peek = 97! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 9/30/2009 00:19'!
testReadWriteStreamPosition
	"ANSI 5.9.1.4 and 5.9.1.5"
	| stream |
	stream := GRPlatform current readWriteCharacterStream.
	stream
		nextPutAll: 'abc';
		reset.
	self assert: stream position = 0.
	stream next.
	self assert: stream position = 1.
	stream next.
	self assert: stream position = 2.
	stream next.
	self assert: stream position = 3.
	stream position: 1.
	self assert: stream position = 1.
	self assert: stream next = $b.
	stream position: 0.
	self assert: stream position = 0.
	self assert: stream next = $a.
	stream position: 3.
	self assert: stream atEnd.
	stream := GRPlatform current readWriteByteStream.
	stream
		nextPutAll: 'abc' asByteArray;
		reset.
	self assert: stream position = 0.
	stream next.
	self assert: stream position = 1.
	stream next.
	self assert: stream position = 2.
	stream next.
	self assert: stream position = 3.
	stream position: 1.
	self assert: stream position = 1.
	self assert: stream next = 98.
	stream position: 0.
	self assert: stream position = 0.
	self assert: stream next = 97.
	stream position: 3.
	self assert: stream atEnd! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 9/30/2009 00:19'!
testReadWriteStreamReset
	"ANSI 5.9.1.6"
	| stream |
	stream := GRPlatform current readWriteCharacterStream.
	stream
		nextPutAll: 'abc';
		reset.
	stream next: 2.
	stream reset.
	self assert: stream next = $a.
	stream := GRPlatform current readWriteCharacterStream.
	stream
		nextPutAll: 'abc';
		reset.
	stream nextPutAll: 'def'.
	self assert: stream contents = 'def'.
	stream := GRPlatform current readWriteByteStream.
	stream
		nextPutAll: 'abc' asByteArray;
		reset.
	stream next: 2.
	stream reset.
	self assert: stream next = 97! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 9/30/2009 00:19'!
testReadWriteStreamSkip
	"ANSI 5.9.2.9"
	| stream |
	stream := GRPlatform current readWriteCharacterStream.
	stream
		nextPutAll: 'abcd';
		reset.
	self assert: (stream
			skip: 2;
			peek) = $c.
	stream := GRPlatform current readWriteByteStream.
	stream
		nextPutAll: 'abcd' asByteArray;
		reset.
	self assert: (stream
			skip: 2;
			peek) = 99! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 9/30/2009 00:19'!
testReadWriteStreamTab
	"ANSI 5.9.4.6"
	| stream |
	stream := GRPlatform current readWriteCharacterStream.
	stream tab.
	self assert: stream contents first = Character tab! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 9/30/2009 00:19'!
testReadWriteStreamUpTo
	"ANSI 5.9.2.11"
	| stream |
	stream := GRPlatform current readWriteCharacterStream.
	stream
		nextPutAll: 'abcd';
		reset.
	self assert: (stream upTo: $c) = 'ab'.
	self assert: stream next = $d.
	stream := GRPlatform current readWriteCharacterStream.
	stream
		nextPutAll: 'abcd';
		reset.
	self assert: (stream upTo: $x) = 'abcd'.
	self assert: stream atEnd.
	stream := GRPlatform current readWriteByteStream.
	stream
		nextPutAll: 'abcd' asByteArray;
		reset.
	self assert: (stream upTo: 99) = #(97 98 ) asByteArray.
	self assert: stream next = 100.
	stream := GRPlatform current readWriteByteStream.
	stream
		nextPutAll: 'abcd' asByteArray;
		reset.
	self assert: (stream upTo: 120) = #(97 98 99 100 ) asByteArray.
	self assert: stream atEnd! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jf 9/30/2009 00:19'!
testReadWriteStreamUpToEnd
	"Not defined by ANSI."
	| stream |
	stream := GRPlatform current readWriteCharacterStream.
	stream
		nextPutAll: 'abcd';
		reset.
	self assert: stream upToEnd = 'abcd'.
	self assert: stream atEnd.
	self assert: stream upToEnd = ''.
	self assert: stream atEnd.
	stream reset.
	stream upTo: $b.
	self assert: stream upToEnd = 'cd'.
	self assert: stream atEnd.
	stream := GRPlatform current readWriteByteStream.
	stream
		nextPutAll: 'abcd' asByteArray;
		reset.
	self assert: stream upToEnd = #(97 98 99 100 ) asByteArray.
	self assert: stream atEnd.
	self assert: stream upToEnd = #() asByteArray.
	self assert: stream atEnd.
	stream reset.
	stream upTo: 98.
	self assert: stream upToEnd = #(99 100 ) asByteArray.
	self assert: stream atEnd! !

!GRPlatformTest methodsFor: 'testing' stamp: 'pmm 12/8/2007 19:59'!
testSeconds
	self assert: Time now seconds isInteger.
	self deny: Time now seconds isFraction! !

!GRPlatformTest methodsFor: 'testing' stamp: 'lr 3/16/2009 19:18'!
testSecureHashFor
	"Make sure the platform class provides a #secureHashFor: method. The method is called by Seaside when hashing passwords. The Squeak implementation returns a SHA-1 hash but another equivalent hash method could also be used."
	
	| a b |
	a := self platform secureHashFor: 'foobar'.
	b := self platform secureHashFor: 'foobar'.
	
	self assert: (a = b)! !

!GRPlatformTest methodsFor: 'testing-image' stamp: 'lr 3/16/2009 19:16'!
testShutDownList
	"A smoke test: checks if the test-class can be added and removed to the shutdown list."
	
	[ self platform addToShutDownList: self class ]
		ensure: [  self platform removeFromShutDownList: self class ]! !

!GRPlatformTest methodsFor: 'testing' stamp: 'lr 9/29/2009 22:54'!
testStackDepth
	| stackDepth someBlock |
	stackDepth := self platform stackDepth.
	self assert: stackDepth isInteger.
	self assert: stackDepth > 0.
	someBlock := [ self assert: self platform stackDepth > stackDepth ].
	someBlock value.
	self assert: stackDepth = self platform stackDepth! !

!GRPlatformTest methodsFor: 'testing-image' stamp: 'lr 3/16/2009 19:16'!
testStartUpList
	"A smoke test: checks if the test-class can be added and removed to the startup list."
	
	[  self platform addToStartUpList: self class ]
		ensure: [  self platform removeFromStartUpList: self class ]! !

!GRPlatformTest methodsFor: 'testing' stamp: 'pmm 2/25/2007 23:08'!
testSymbolAsMutator
	"test for:
	Symbol >> #asMutator
	^ (self copyWith: $:) asSymbol"
	self assert: #name asMutator = #name:! !

!GRPlatformTest methodsFor: 'testing-processes' stamp: 'mlucas-smith 6/3/2009 22:33'!
testTerminate
	| ensureRun ifCurtailedRun semaphore1 semaphore2 semaphore3 semaphore4 process |
	ensureRun := false.
	ifCurtailedRun := false.
	semaphore1 := self platform semaphoreClass new.
	semaphore2 := self platform semaphoreClass new.
	semaphore3 := self platform semaphoreClass new.
	semaphore4 := self platform semaphoreClass new.
	process := [
		[ [ semaphore1 signal. semaphore2 wait ]
			ensure: [ ensureRun := true. semaphore3 signal ] ]
			ifCurtailed: [ ifCurtailedRun := true. semaphore4 signal ] ] newProcess.
	self deny: (self platform isProcessTerminated: process).
	process resume.
	semaphore1 wait.
	self deny: (self platform isProcessTerminated: process).
	self platform terminateProcess: process.
	semaphore3 wait.
	self assert: ensureRun.
	semaphore4 wait.
	self assert: ifCurtailedRun.
	self assert: (self platform isProcessTerminated: process)! !

!GRPlatformTest methodsFor: 'testing' stamp: 'lr 6/5/2009 08:59'!
testTotalSeconds
	"Answer the total seconds since the Squeak epoch: 1 January 1901."

	| seconds |
	seconds := Time totalSeconds.
	self assert: seconds isInteger.
	self assert: seconds > 3421645167! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'lr 2/1/2009 12:42'!
testWriteStreamContents
	"ANSI 5.9.3.1"
	
	| stream |
	stream := WriteStream on: String new.
	stream nextPutAll: 'abc'.
	self assert: stream contents = 'abc'.
	stream nextPutAll: 'def'.
	self assert: stream contents = 'abcdef'! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'mlucas-smith 6/3/2009 22:33'!
testWriteStreamCrLf
	| stream |
	stream := WriteStream on: String new.
	stream crlf.
	self assert: stream contents first codePoint = 13.
	self assert: stream contents second codePoint = 10! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jgf 1/23/2009 15:29'!
testWriteStreamNextPut
	"ANSI 5.9.4.3"
	
	| stream |
	stream := WriteStream on: String new.
	stream nextPut: $a.
	self assert: stream contents = 'a'! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jgf 1/23/2009 15:28'!
testWriteStreamNextPutAll
	"ANSI 5.9.4.4"
	
	| stream |
	stream := WriteStream on: String new.
	stream nextPutAll: 'abc'.
	self assert: stream contents = 'abc'.
	
	stream := WriteStream on: String new.
	stream nextPutAll: #($a $b $c).
	self assert: stream contents = 'abc'! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jgf 1/23/2009 15:28'!
testWriteStreamReset
	"ANSI 5.9.1.6"
	
	| stream |
	stream := WriteStream on: String new.
	stream nextPutAll: 'abc'.
	stream reset.
	stream nextPutAll: 'def'.
	self assert: stream contents = 'def'! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jgf 1/23/2009 15:28'!
testWriteStreamSpace
	"ANSI 5.9.4.5"
	
	| stream |
	stream := WriteStream on: String new.
	stream space.
	self assert: stream contents first = Character space! !

!GRPlatformTest methodsFor: 'testing-streams' stamp: 'jgf 1/23/2009 15:28'!
testWriteStreamTab
	"ANSI 5.9.4.6"
	
	| stream |
	stream := WriteStream on: String new.
	stream tab.
	self assert: stream contents first = Character tab! !

TestCase subclass: #GRPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRPrinterTest class methodsFor: 'accessing' stamp: 'lr 2/6/2010 10:14'!
packageNamesUnderTest
	^ #('Grease-Core')! !

!GRPrinterTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:33'!
testComposedPrinter
	| converter |
	converter := GRSequentialPrinter new , 'CHF ' , GRNumberPrinter new.
	self assert: (converter print: 1234) = 'CHF 1234'.
	self assert: (converter print: -1234) = 'CHF 1234'.
	converter := GRSignPrinter new , GRNumberPrinter new , '%'.
	self assert: (converter print: 1234) = '1234%'.
	self assert: (converter print: -1234) = '-1234%'! !

!GRPrinterTest methodsFor: 'testing-timestamp' stamp: 'lr 2/6/2010 11:12'!
testCookieTimestamp
	| printer date |
	printer := GRPrinter cookieTimestamp.
	date := DateAndTime 
		year: 2008
		month: 8
		day: 1
		hour: 9
		minute: 4
		second: 4
		offset: (Duration 
				days: 0
				hours: 0
				minutes: 0
				seconds: 0).
	self assert: (printer print: date) = 'Fri, 01-Aug-2008 09:04:04 GMT'! !

!GRPrinterTest methodsFor: 'testing-utilites' stamp: 'jf 9/30/2009 00:32'!
testDigitsOf
	| converter |
	converter := GRNumberPrinter new.
	self assert: (converter 
			digitsOf: 0.0
			base: 10) = '0'.
	self assert: (converter 
			digitsOf: 1.0
			base: 10) = '1'.
	self assert: (converter 
			digitsOf: -1.0
			base: 10) = '1'.
	self assert: (converter 
			digitsOf: -1234567890
			base: 10) = '1234567890'.
	self assert: (converter 
			digitsOf: 1234567890
			base: 10) = '1234567890'.
	self assert: (converter 
			digitsOf: -9876543210
			base: 10) = '9876543210'.
	self assert: (converter 
			digitsOf: 9876543210
			base: 10) = '9876543210'! !

!GRPrinterTest methodsFor: 'testing-utilites' stamp: 'jf 9/30/2009 00:32'!
testDigitsOfBase
	| converter |
	converter := GRNumberPrinter new.
	self assert: (converter 
			digitsOf: 1234
			base: 2) = '10011010010'.
	self assert: (converter 
			digitsOf: 1234
			base: 3) = '1200201'.
	self assert: (converter 
			digitsOf: 1234
			base: 4) = '103102'.
	self assert: (converter 
			digitsOf: 1234
			base: 5) = '14414'.
	self assert: (converter 
			digitsOf: 1234
			base: 6) = '5414'.
	self assert: (converter 
			digitsOf: 1234
			base: 7) = '3412'.
	self assert: (converter 
			digitsOf: 1234
			base: 8) = '2322'.
	self assert: (converter 
			digitsOf: 1234
			base: 9) = '1621'.
	self assert: (converter 
			digitsOf: 1234
			base: 10) = '1234'.
	self assert: (converter 
			digitsOf: 1234
			base: 11) = 'a22'.
	self assert: (converter 
			digitsOf: 1234
			base: 12) = '86a'.
	self assert: (converter 
			digitsOf: 1234
			base: 13) = '73c'.
	self assert: (converter 
			digitsOf: 1234
			base: 14) = '642'.
	self assert: (converter 
			digitsOf: 1234
			base: 15) = '574'.
	self assert: (converter 
			digitsOf: 1234
			base: 16) = '4d2'! !

!GRPrinterTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:32'!
testFileSizePrinterBinary
	| converter |
	converter := GRPrinter binaryFileSize.
	self assert: (converter print: 1) = '1 byte'.
	self assert: (converter print: 2) = '2 bytes'.
	self assert: (converter print: 30) = '30 bytes'.
	self assert: (converter print: 500) = '500 bytes'.
	self assert: (converter print: 6000) = '5.9 KiB'.
	self assert: (converter print: 70000) = '68.4 KiB'.
	self assert: (converter print: 800000) = '781.3 KiB'.
	self assert: (converter print: 9000000) = '8.6 MiB'.
	self assert: (converter print: 10000000) = '9.5 MiB'.
	self assert: (converter print: 200000000) = '190.7 MiB'.
	self assert: (converter print: 3000000000) = '2.8 GiB'.
	self assert: (converter print: 40000000000) = '37.3 GiB'! !

!GRPrinterTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:32'!
testFileSizePrinterDecimal
	| converter |
	converter := GRPrinter decimalFileSize.
	self assert: (converter print: 1) = '1 byte'.
	self assert: (converter print: 2) = '2 bytes'.
	self assert: (converter print: 30) = '30 bytes'.
	self assert: (converter print: 500) = '500 bytes'.
	self assert: (converter print: 6000) = '6.0 kB'.
	self assert: (converter print: 70000) = '70.0 kB'.
	self assert: (converter print: 800000) = '800.0 kB'.
	self assert: (converter print: 9000000) = '9.0 MB'.
	self assert: (converter print: 10000000) = '10.0 MB'.
	self assert: (converter print: 200000000) = '200.0 MB'.
	self assert: (converter print: 3000000000) = '3.0 GB'.
	self assert: (converter print: 40000000000) = '40.0 GB'! !

!GRPrinterTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:32'!
testFloatPrinter
	| converter |
	converter := GRNumberPrinter new precision: 2.
	self assert: (converter print: 1.009) = '1.01'.
	self assert: (converter print: 1.01) = '1.01'.
	self assert: (converter print: 1.019) = '1.02'.
	self assert: (converter print: 1.25) = '1.25'.
	self assert: (converter print: 1.254) = '1.25'.
	self assert: (converter print: 1.256) = '1.26'.
	self assert: (converter print: 1.009) = '1.01'.
	self assert: (converter print: 0.9) = '0.90'.
	self assert: (converter print: 0.99) = '0.99'.
	self assert: (converter print: 0.999) = '1.00'.
	self assert: (converter print: 0.9999) = '1.00'.
	self assert: (converter print: -0.9) = '0.90'.
	self assert: (converter print: -0.99) = '0.99'.
	self assert: (converter print: -0.999) = '1.00'.
	self assert: (converter print: -0.9999) = '1.00'! !

!GRPrinterTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:32'!
testFloatPrinterInfinity
	| converter |
	converter := GRNumberPrinter new.
	self assert: (converter print: Float infinity) = 'Infinite'.
	self assert: (converter print: Float infinity negated) = 'Infinite'.
	converter infinite: 'very huge'.
	self assert: (converter print: Float infinity) = 'very huge'.
	self assert: (converter print: Float infinity negated) = 'very huge'! !

!GRPrinterTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:32'!
testFloatPrinterNaN
	| converter |
	converter := GRNumberPrinter new.
	self assert: (converter print: Float nan) = 'NaN'.
	converter nan: 'Not A Number'.
	self assert: (converter print: Float nan) = 'Not A Number'! !

!GRPrinterTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:32'!
testFloatPrinterPadding
	| converter |
	converter := GRNumberPrinter new.
	converter digits: 3.
	self assert: (converter print: 1) = '  1'.
	self assert: (converter print: 12) = ' 12'.
	self assert: (converter print: 123) = '123'.
	self assert: (converter print: 1234) = '1234'.
	converter padding: $*.
	self assert: (converter print: 1) = '**1'.
	self assert: (converter print: 12) = '*12'.
	self assert: (converter print: 123) = '123'.
	self assert: (converter print: 1234) = '1234'! !

!GRPrinterTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:32'!
testFloatPrinterSeparator
	| converter |
	converter := GRNumberPrinter new.
	converter
		precision: 2;
		separator: $*.
	self assert: (converter print: 12345.0) = '12*345.00'.
	self assert: (converter print: 0.6789) = '0.68'.
	converter
		precision: 4;
		separator: $!!.
	self assert: (converter print: 12345.0) = '12!!345.000!!0'.
	self assert: (converter print: 0.6789) = '0.678!!9'! !

!GRPrinterTest methodsFor: 'testing-parts-date' stamp: 'lr 2/6/2010 11:09'!
testFullMonthName
	| printer |
	printer := GRPrinter fullMonthName.
	self assert: (printer print: (Date year: 2000 month: 8 day: 1)) = 'August'.
	self assert: (printer print: (Date year: 2000 month: 11 day: 1)) = 'November'! !

!GRPrinterTest methodsFor: 'testing-parts-date' stamp: 'lr 2/6/2010 11:10'!
testFullWeekName
	| printer |
	printer := GRPrinter fullWeekName.
	self assert: (printer print: (Date year: 1980 month: 1 day: 1)) = 'Tuesday'.
	self assert: (printer print: (Date year: 2000 month: 1 day: 1)) = 'Saturday'! !

!GRPrinterTest methodsFor: 'testing-timestamp' stamp: 'jf 9/30/2009 00:32'!
testHttp
	| printer date offsetHour |
	offsetHour := 2.
	printer := GRPrinter httpDate.
	date := DateAndTime 
		year: 1994
		month: 11
		day: 6
		hour: 8 + offsetHour
		minute: 49
		second: 37
		offset: (Duration 
				days: 0
				hours: offsetHour
				minutes: 0
				seconds: 0).
	self assert: (printer print: date) = 'Sun, 06 Nov 1994 08:49:37 GMT'! !

!GRPrinterTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:32'!
testIntegerPrinter
	| converter |
	converter := GRNumberPrinter new.
	self assert: (converter print: 1234) = '1234'.
	self assert: (converter print: -1234) = '1234'.
	converter separator: $..
	self assert: (converter print: 1234) = '1.234'.
	self assert: (converter print: 1234567) = '1.234.567'.
	converter
		base: 16;
		separator: nil.
	self assert: (converter print: 1234) = '4d2'.
	self assert: (converter print: 123123) = '1e0f3'.
	converter uppercase.
	self assert: (converter print: 1234) = '4D2'.
	self assert: (converter print: 123123) = '1E0F3'! !

!GRPrinterTest methodsFor: 'testing-timestamp' stamp: 'jf 9/30/2009 00:32'!
testIsoDate
	| printer |
	printer := GRPrinter isoDate.
	self assert: (printer print: (Date 
				year: 1980
				month: 6
				day: 11)) = '1980-06-11'.
	self assert: (printer print: (Date 
				year: 2003
				month: 12
				day: 1)) = '2003-12-01'.
	self assert: (printer print: (Date 
				year: 800
				month: 12
				day: 24)) = '0800-12-24'! !

!GRPrinterTest methodsFor: 'testing-timestamp' stamp: 'jf 9/30/2009 00:32'!
testIsoTime
	| printer |
	printer := GRPrinter isoTime.
	self assert: (printer print: (Time 
				hour: 0
				minute: 0
				second: 0)) = '00:00:00'.
	self assert: (printer print: (Time 
				hour: 1
				minute: 2
				second: 3)) = '01:02:03'.
	self assert: (printer print: (Time 
				hour: 12
				minute: 23
				second: 34)) = '12:23:34'! !

!GRPrinterTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:32'!
testOrdinalizePrinter
	| converter |
	converter := GRNumberPrinter new , GROrdinalizePrinter new.
	self assert: (converter print: 1) = '1st'.
	self assert: (converter print: 2) = '2nd'.
	self assert: (converter print: 3) = '3rd'.
	self assert: (converter print: 4) = '4th'.
	self assert: (converter print: 10) = '10th'.
	self assert: (converter print: 111) = '111th'.
	self assert: (converter print: 212) = '212th'.
	self assert: (converter print: 313) = '313th'.
	self assert: (converter print: 414) = '414th'.
	self assert: (converter print: 20) = '20th'.
	self assert: (converter print: 121) = '121st'.
	self assert: (converter print: 222) = '222nd'.
	self assert: (converter print: 323) = '323rd'.
	self assert: (converter print: 424) = '424th'! !

!GRPrinterTest methodsFor: 'testing-utilites' stamp: 'jf 9/30/2009 00:32'!
testPadCenter
	| converter |
	converter := GRPrinter new.
	self assert: (converter 
			pad: ''
			center: $*
			to: 3) = '***'.
	self assert: (converter 
			pad: '1'
			center: $*
			to: 3) = '*1*'.
	self assert: (converter 
			pad: '12'
			center: $*
			to: 3) = '12*'.
	self assert: (converter 
			pad: '123'
			center: $*
			to: 3) = '123'.
	self assert: (converter 
			pad: '1234'
			center: $*
			to: 3) = '1234'! !

!GRPrinterTest methodsFor: 'testing-utilites' stamp: 'jf 9/30/2009 00:32'!
testPadLeft
	| converter |
	converter := GRPrinter new.
	self assert: (converter 
			pad: ''
			left: $*
			to: 3) = '***'.
	self assert: (converter 
			pad: '1'
			left: $*
			to: 3) = '**1'.
	self assert: (converter 
			pad: '12'
			left: $*
			to: 3) = '*12'.
	self assert: (converter 
			pad: '123'
			left: $*
			to: 3) = '123'.
	self assert: (converter 
			pad: '1234'
			left: $*
			to: 3) = '1234'! !

!GRPrinterTest methodsFor: 'testing-utilites' stamp: 'jf 9/30/2009 00:32'!
testPadRight
	| converter |
	converter := GRPrinter new.
	self assert: (converter 
			pad: ''
			right: $*
			to: 3) = '***'.
	self assert: (converter 
			pad: '1'
			right: $*
			to: 3) = '1**'.
	self assert: (converter 
			pad: '12'
			right: $*
			to: 3) = '12*'.
	self assert: (converter 
			pad: '123'
			right: $*
			to: 3) = '123'.
	self assert: (converter 
			pad: '1234'
			right: $*
			to: 3) = '1234'! !

!GRPrinterTest methodsFor: 'testing-parts-date' stamp: 'lr 2/6/2010 11:03'!
testPaddedCentury
	| printer |
	printer := GRPrinter paddedCentury.
	self assert: (printer print: (Date year: 1980 month: 1 day: 1)) = '80'.
	self assert: (printer print: (Date year: 2009 month: 1 day: 1)) = '09'! !

!GRPrinterTest methodsFor: 'testing-parts-time' stamp: 'lr 2/6/2010 11:07'!
testPaddedHour12
	| printer |
	printer := GRPrinter paddedHour12.
	self assert: (printer print: (Time hour: 5 minute: 0 second: 0)) = '05'.
	self assert: (printer print: (Time hour: 10 minute: 0 second: 0)) = '10'.
	self assert: (printer print: (Time hour: 14 minute: 0 second: 0)) = '02'.
	self assert: (printer print: (Time hour: 23 minute: 0 second: 0)) = '11'! !

!GRPrinterTest methodsFor: 'testing-timestamp' stamp: 'jf 9/30/2009 00:32'!
testRfc822
	| printer date |
	printer := GRPrinter rfc822.
	date := DateAndTime 
		year: 2008
		month: 8
		day: 1
		hour: 9
		minute: 4
		second: 4
		offset: (Duration 
				days: 0
				hours: -2
				minutes: 0
				seconds: 0).
	self assert: (printer print: date) = 'Fri, 01 Aug 2008 09:04:04 -0200'.
	date := DateAndTime 
		year: 2008
		month: 8
		day: 31
		hour: 19
		minute: 41
		second: 46
		offset: (Duration 
				days: 0
				hours: 0
				minutes: 30
				seconds: 0).
	self assert: (printer print: date) = 'Sun, 31 Aug 2008 19:41:46 +0030'! !

!GRPrinterTest methodsFor: 'testing-timestamp' stamp: 'lr 2/6/2010 11:12'!
testRfc822WithTimeZone
	| printer date |
	printer := GRPrinter rfc822WithTimeZone: 'GMT'.
	date := DateAndTime 
		year: 2008
		month: 8
		day: 1
		hour: 9
		minute: 4
		second: 4
		offset: (Duration 
				days: 0
				hours: 0
				minutes: 0
				seconds: 0).
	self assert: (printer print: date) = 'Fri, 01 Aug 2008 09:04:04 GMT'! !

!GRPrinterTest methodsFor: 'testing-utilites' stamp: 'jf 9/30/2009 00:32'!
testSeparateLeft
	| converter |
	converter := GRNumberPrinter new.
	self assert: (converter 
			separate: ''
			left: $*) = ''.
	self assert: (converter 
			separate: '1'
			left: $*) = '1'.
	self assert: (converter 
			separate: '12'
			left: $*) = '12'.
	self assert: (converter 
			separate: '123'
			left: $*) = '123'.
	self assert: (converter 
			separate: '1234'
			left: $*) = '123*4'.
	self assert: (converter 
			separate: '12345'
			left: $*) = '123*45'.
	self assert: (converter 
			separate: '123456'
			left: $*) = '123*456'.
	self assert: (converter 
			separate: '1234567'
			left: $*) = '123*456*7'.
	self assert: (converter 
			separate: '12345678'
			left: $*) = '123*456*78'.
	self assert: (converter 
			separate: '123456789'
			left: $*) = '123*456*789'! !

!GRPrinterTest methodsFor: 'testing-utilites' stamp: 'jf 9/30/2009 00:32'!
testSeparateRight
	| converter |
	converter := GRNumberPrinter new.
	self assert: (converter 
			separate: ''
			right: $*) = ''.
	self assert: (converter 
			separate: '1'
			right: $*) = '1'.
	self assert: (converter 
			separate: '12'
			right: $*) = '12'.
	self assert: (converter 
			separate: '123'
			right: $*) = '123'.
	self assert: (converter 
			separate: '1234'
			right: $*) = '1*234'.
	self assert: (converter 
			separate: '12345'
			right: $*) = '12*345'.
	self assert: (converter 
			separate: '123456'
			right: $*) = '123*456'.
	self assert: (converter 
			separate: '1234567'
			right: $*) = '1*234*567'.
	self assert: (converter 
			separate: '12345678'
			right: $*) = '12*345*678'.
	self assert: (converter 
			separate: '123456789'
			right: $*) = '123*456*789'! !

!GRPrinterTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:33'!
testSignPrinter
	| converter |
	converter := GRSignPrinter new.
	converter
		negativePrinter: $-;
		positivePrinter: $+.
	self assert: (converter print: 12) = '+'.
	self assert: (converter print: -12) = '-'! !

!GRPrinterTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:33'!
testStringPrinter
	| converter |
	converter := GRStringPrinter new.
	self assert: (converter print: 123) = '123'.
	self assert: (converter print: 'foo') = 'foo'.
	self assert: (converter print: true) = 'true'! !

!GRPrinterTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:33'!
testStringPrinterLength
	| converter |
	converter := GRStringPrinter new.
	self assert: (converter print: 'foo') = 'foo'.
	converter length: 3.
	self assert: (converter print: 'foo') = 'foo'.
	converter length: 1.
	self assert: (converter print: 'foo') = 'f'! !

!GRPrinterTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:33'!
testStringPrinterPad
	| converter |
	converter := GRStringPrinter new.
	converter
		character: $*;
		length: 5.
	converter padLeft.
	self assert: (converter print: 'foo') = '**foo'.
	converter padRight.
	self assert: (converter print: 'foo') = 'foo**'.
	converter padCenter.
	self assert: (converter print: 'foo') = '*foo*'! !

!GRPrinterTest methodsFor: 'testing' stamp: 'jf 9/30/2009 00:33'!
testStringPrinterTrim
	| converter |
	converter := GRStringPrinter new.
	self assert: (converter print: ' foo ') = ' foo '.
	converter trimLeft.
	self assert: (converter print: ' foo ') = 'foo '.
	converter trimRight.
	self assert: (converter print: ' foo ') = ' foo'.
	converter trimBoth.
	self assert: (converter print: ' foo ') = 'foo'! !

!GRPrinterTest methodsFor: 'testing-currency' stamp: 'jf 9/30/2009 00:32'!
testSwissCurrency
	| printer |
	printer := GRPrinter swissCurrency.
	self assert: (printer print: 12.34) = 'CHF 12.35'.
	self assert: (printer print: -12.39) = 'CHF -12.40'! !

!GRPrinterTest methodsFor: 'testing-parts-date' stamp: 'lr 2/6/2010 11:10'!
testUnpaddedCentury
	| printer |
	printer := GRPrinter unpaddedCentury.
	self assert: (printer print: (Date year: 1980 month: 1 day: 1)) = '80'.
	self assert: (printer print: (Date year: 2009 month: 1 day: 1)) = '9'! !

!GRPrinterTest methodsFor: 'testing-parts-date' stamp: 'lr 2/6/2010 11:09'!
testUnpaddedDay
	| printer |
	printer := GRPrinter unpaddedDay.
	self assert: (printer print: (Date year: 2000 month: 1 day: 4)) = '4'.
	self assert: (printer print: (Date year: 2000 month: 1 day: 19)) = '19'! !

!GRPrinterTest methodsFor: 'testing-parts-time' stamp: 'lr 2/6/2010 11:05'!
testUnpaddedHour12
	| printer |
	printer := GRPrinter unpaddedHour12.
	self assert: (printer print: (Time hour: 5 minute: 0 second: 0)) = '5'.
	self assert: (printer print: (Time hour: 10 minute: 0 second: 0)) = '10'.
	self assert: (printer print: (Time hour: 14 minute: 0 second: 0)) = '2'.
	self assert: (printer print: (Time hour: 23 minute: 0 second: 0)) = '11'! !

!GRPrinterTest methodsFor: 'testing-parts-time' stamp: 'lr 2/6/2010 11:07'!
testUnpaddedHour24
	| printer |
	printer := GRPrinter unpaddedHour24.
	self assert: (printer print: (Time hour: 5 minute: 0 second: 0)) = '5'.
	self assert: (printer print: (Time hour: 10 minute: 0 second: 0)) = '10'.
	self assert: (printer print: (Time hour: 14 minute: 0 second: 0)) = '14'.
	self assert: (printer print: (Time hour: 23 minute: 0 second: 0)) = '23'! !

!GRPrinterTest methodsFor: 'testing-parts-time' stamp: 'lr 2/6/2010 11:02'!
testUnpaddedMinute
	| printer |
	printer := GRPrinter unpaddedMinute.
	self assert: (printer print: (Time hour: 0 minute: 5 second: 0)) = '5'.
	self assert: (printer print: (Time hour: 0 minute: 12 second: 0)) = '12'! !

!GRPrinterTest methodsFor: 'testing-parts-date' stamp: 'lr 2/6/2010 11:07'!
testUnpaddedMonth
	| printer |
	printer := GRPrinter unpaddedMonth.
	self assert: (printer print: (Date year: 2000 month: 8 day: 1)) = '8'.
	self assert: (printer print: (Date year: 2000 month: 11 day: 1)) = '11'! !

!GRPrinterTest methodsFor: 'testing-parts-time' stamp: 'lr 2/6/2010 11:06'!
testUnpaddedSecond
	| printer |
	printer := GRPrinter unpaddedSecond.
	self assert: (printer print: (Time hour: 0 minute: 0 second: 0)) = '0'.
	self assert: (printer print: (Time hour: 0 minute: 0 second: 9)) = '9'.
	self assert: (printer print: (Time hour: 0 minute: 0 second: 12)) = '12'! !

!GRPrinterTest methodsFor: 'testing-parts-date' stamp: 'lr 2/6/2010 11:08'!
testUnpaddedYear
	| printer |
	printer := GRPrinter unpaddedYear.
	self assert: (printer print: (Date year: 766 month: 1 day: 1)) = '766'.
	self assert: (printer print: (Date year: 1980 month: 1 day: 1)) = '1980'.
	self assert: (printer print: (Date year: 2009 month: 1 day: 1)) = '2009'! !

!GRPrinterTest methodsFor: 'testing-currency' stamp: 'jf 9/30/2009 00:32'!
testUsCurrency
	| printer |
	printer := GRPrinter usCurrency.
	self assert: (printer print: 12.34) = '$12.34'.
	self assert: (printer print: -12.34) = '-$12.34'! !

TestCase subclass: #GRSmallDictionaryTest
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRSmallDictionaryTest methodsFor: 'running' stamp: 'jf 9/30/2009 00:26'!
setUp
	super setUp.
	dictionary := GRSmallDictionary new! !

!GRSmallDictionaryTest methodsFor: 'testing-accessing' stamp: 'pmm 8/30/2009 18:09'!
testAdd
	| association |
	association := dictionary add: '1' -> 'foo'.
	self assert: (dictionary at: '1') = 'foo'.
	self assert: association key = '1'.
	self assert: association value = 'foo'.
	
	association := dictionary add: '1' -> 'bar'.
	self assert: (dictionary at: '1') = 'bar'.
	self assert: association key = '1'.
	self assert: association value = 'bar'.! !

!GRSmallDictionaryTest methodsFor: 'testing-enumerating' stamp: 'lr 8/20/2007 13:47'!
testAssociations
	dictionary at: '1' put: 'foo'; at: '2' put: 'bar'.
	self assert: dictionary associations = (Array with: '1' -> 'foo' with: '2' -> 'bar')! !

!GRSmallDictionaryTest methodsFor: 'testing-enumerating' stamp: 'lr 10/28/2007 14:42'!
testAssociationsDo
	dictionary associationsDo: [ :key :valye |
		self assert: false ].
	dictionary at: '1' put: 'foo'; at: '2' put: 'bar'.
	dictionary associationsDo: [ :assoc |
		self assert: ((assoc key = '1' and: [ assoc value = 'foo'])
			or: [ assoc key = '2' and: [ assoc value = 'bar' ] ]) ]! !

!GRSmallDictionaryTest methodsFor: 'testing-accessing' stamp: 'lr 7/12/2007 13:19'!
testAt
	self should: [ dictionary at: '1' ] raise: Error.
	dictionary at: '1' put: 'foo'.
	self assert: (dictionary at: '1') = 'foo'! !

!GRSmallDictionaryTest methodsFor: 'testing-accessing' stamp: 'lr 2/22/2009 11:11'!
testAtAppend
	dictionary at: '1' append: 'foo'.
	dictionary at: '1' append: 'bar'.
	self assert: dictionary size = 2.
	self assert: dictionary keys = #('1' '1').
	self assert: dictionary values = #('foo' 'bar').
	self assert: (dictionary at: '1') = 'foo'! !

!GRSmallDictionaryTest methodsFor: 'testing-accessing' stamp: 'lr 7/9/2007 10:47'!
testAtIfAbsent
	self assert: (dictionary at: '1' ifAbsent: [ 'foo' ]) = 'foo'.
	dictionary at: '1' put: 'bar'.
	self assert: (dictionary at: '1' ifAbsent: [ 'foo' ]) = 'bar'! !

!GRSmallDictionaryTest methodsFor: 'testing-accessing' stamp: 'lr 7/9/2007 10:50'!
testAtIfAbsentPut
	self assert: (dictionary at: '1' ifAbsentPut: [ 'foo' ]) = 'foo'.
	self assert: (dictionary at: '1' ifAbsentPut: [ 'bar' ]) = 'foo'! !

!GRSmallDictionaryTest methodsFor: 'testing-accessing' stamp: 'lr 7/9/2007 10:51'!
testAtIfPresent
	dictionary at: '1' put: 'foo'.
	self assert: (dictionary at: '1' ifPresent: [ :v | v , 'bar' ]) = 'foobar'.
	self assert: (dictionary at: '2' ifPresent: [ :v | v , 'bar' ]) isNil! !

!GRSmallDictionaryTest methodsFor: 'testing-accessing' stamp: 'lr 7/9/2007 10:48'!
testAtPut
	dictionary at: '1' put: 'foo'.
	self assert: (dictionary at: '1') = 'foo'.
	dictionary at: '1' put: 'bar'.
	self assert: (dictionary at: '1') = 'bar'! !

!GRSmallDictionaryTest methodsFor: 'testing' stamp: 'lr 7/16/2009 21:24'!
testCopy
	| other |
	dictionary at: 1 put: 'foo'; at: 2 put: 'bar'.
	other := dictionary copy.
	dictionary at: 1 put: 'zork'; at: 3 put: 'zonk'.
	other at: 2 put: 'other'.
	
	self assert: dictionary size = 3.
	self assert: (dictionary at: 1) = 'zork'.
	self assert: (dictionary at: 2) = 'bar'.
	self assert: (dictionary at: 3) = 'zonk'.
	
	self assert: other size = 2.
	self assert: (other at: 1) = 'foo'.
	self assert: (other at: 2) = 'other'! !

!GRSmallDictionaryTest methodsFor: 'testing-enumerating' stamp: 'jf 12/29/2009 20:41'!
testDo
	| result |
	result := OrderedCollection new.
	dictionary at: '1' put: 'foo'; at: '2' put: 'bar'.
	dictionary do: [ :each | result add: each ].
	self assert: result asArray = #( 'foo' 'bar' )! !

!GRSmallDictionaryTest methodsFor: 'testing' stamp: 'lr 7/16/2009 21:28'!
testGrow
	1 to: 100 do: [ :i |
		dictionary at: i put: i negated.
		self assert: dictionary size = i.
		[ :array :factor |
			self assert: array size = i.
			1 to: i do: [ :j | self assert: (array at: j) = (factor * j) ] ]
				value: dictionary keys value: 1;
				value: dictionary values value: -1 ]! !

!GRSmallDictionaryTest methodsFor: 'testing-testing' stamp: 'lr 8/17/2007 11:55'!
testIncludesKey
	self deny: (dictionary includesKey: '1').
	dictionary at: '1' put: 'foo'.
	self assert: (dictionary includesKey: '1')! !

!GRSmallDictionaryTest methodsFor: 'testing-testing' stamp: 'lr 7/9/2007 10:53'!
testIsEmpty
	self assert: dictionary isEmpty.
	dictionary at: '1' put: 'foo'.
	self deny: dictionary isEmpty! !

!GRSmallDictionaryTest methodsFor: 'testing-enumerating' stamp: 'lr 7/9/2007 10:52'!
testKeys
	dictionary at: '1' put: 'foo'; at: '2' put: 'bar'.
	self assert: dictionary keys = #( '1' '2' )! !

!GRSmallDictionaryTest methodsFor: 'testing-enumerating' stamp: 'lr 10/28/2007 14:42'!
testKeysAndValuesDo
	dictionary keysAndValuesDo: [ :key :valye |
		self assert: false ].
	dictionary at: '1' put: 'foo'; at: '2' put: 'bar'.
	dictionary keysAndValuesDo: [ :key :value |
		self assert: ((key = '1' and: [ value = 'foo'])
			or: [ key = '2' and: [ value = 'bar' ] ]) ]! !

!GRSmallDictionaryTest methodsFor: 'testing-enumerating' stamp: 'lr 8/17/2007 11:54'!
testKeysDo
	| result |
	result := OrderedCollection new.
	dictionary at: '1' put: 'foo'; at: '2' put: 'bar'.
	dictionary keysDo: [ :each | result add: each ].
	self assert: result asArray = #( '1' '2' )! !

!GRSmallDictionaryTest methodsFor: 'testing-accessing' stamp: 'lr 7/12/2007 13:20'!
testRemoveKey
	dictionary at: '1' put: 'foo'.
	self assert: (dictionary removeKey: '1') = 'foo'.
	self should: [ dictionary removeKey: '1' ] raise: Error! !

!GRSmallDictionaryTest methodsFor: 'testing-accessing' stamp: 'lr 7/9/2007 10:51'!
testRemoveKeyIfAbsent
	dictionary at: '1' put: 'foo'.
	self assert: (dictionary removeKey: '1' ifAbsent: [ 'bar' ]) = 'foo'.
	self assert: (dictionary removeKey: '1' ifAbsent: [ 'bar' ]) = 'bar'! !

!GRSmallDictionaryTest methodsFor: 'testing-accessing' stamp: 'pmm 11/3/2008 17:22'!
testSize
	self assert: dictionary isEmpty.
	dictionary at: '1' put: 'foo'.
	self assert: dictionary size = 1.
	dictionary at: '2' put: 'bar'.
	self assert: dictionary size = 2! !

!GRSmallDictionaryTest methodsFor: 'testing-enumerating' stamp: 'lr 7/9/2007 10:54'!
testValues
	dictionary at: '1' put: 'foo'; at: '2' put: 'bar'.
	self assert: dictionary values = #( 'foo' 'bar' )! !

TestCase subclass: #GRStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRStringTest methodsFor: 'testing' stamp: 'jf 9/25/2009 16:50'!
testAsUppercase
	self assert: 'abc' asUppercase = 'ABC'.
	self assert: 'ABC' asUppercase = 'ABC'! !

!GRStringTest methodsFor: 'testing' stamp: 'jf 9/25/2009 16:50'!
testCapitalized
	self assert: 'capitalized' capitalized = 'Capitalized'.
	self assert: 'Capitalized' capitalized = 'Capitalized'.
	self assert: 'CAPITALIZED' capitalized = 'CAPITALIZED'.
	self assert: #'capitalized' capitalized = #'Capitalized'.
	self assert: #'Capitalized' capitalized = #'Capitalized'.
	self assert: #'CAPITALIZED' capitalized = #'CAPITALIZED'.! !

!GRStringTest methodsFor: 'testing' stamp: 'jf 9/25/2009 16:50'!
testCapitalizedUmlauts
	self assert: '' capitalized = ''.
	self assert: '' capitalized = ''.
	self assert: '' capitalized = ''.
	self assert: #'' capitalized = #''.
	self assert: #'' capitalized = #''.
	self assert: #'' capitalized = #''! !

!GRStringTest methodsFor: 'testing' stamp: 'jf 9/25/2009 16:49'!
testCopyAfter
	self assert: ('de_CH' copyAfter: $_) = 'CH'! !

!GRStringTest methodsFor: 'testing' stamp: 'jf 9/25/2009 16:49'!
testCopyAfterLast
	self assert: ('britney.sex.tape.mkv' copyAfterLast: $.) = 'mkv'.
	self assert: ('britney.sex.tape.mkv' copyAfterLast: $$) = ''! !

!GRStringTest methodsFor: 'testing' stamp: 'jf 9/25/2009 16:49'!
testCopyUpTo
	self assert: ('britney.sex.tape.mkv' copyUpTo: $.) = 'britney'.
	self assert: ('britney.sex.tape.mkv' copyUpTo: $$) = 'britney.sex.tape.mkv'! !

!GRStringTest methodsFor: 'testing' stamp: 'jf 9/25/2009 16:49'!
testCopyUpToLast
	self assert: ('britney.sex.tape.mkv' copyUpToLast: $.) = 'britney.sex.tape'! !

!GRStringTest methodsFor: 'testing-excerpt' stamp: 'lr 2/7/2008 09:31'!
testExcerpt
	self assert: ('abcde' excerpt: 'c' radius: 0) = '...c...'.
	self assert: ('abcde' excerpt: 'c' radius: 1) = '...bcd...'.
	self assert: ('abcde' excerpt: 'c' radius: 2) = 'abcde'.
	self assert: ('abcde' excerpt: 'c' radius: 3) = 'abcde'.
	
	self assert: ('abcde' excerpt: 'c' radius: 0 ellipsis: 'x') = 'xcx'.
	self assert: ('abcde' excerpt: 'c' radius: 1 ellipsis: 'x') = 'xbcdx'.
	self assert: ('abcde' excerpt: 'c' radius: 2 ellipsis: 'x') = 'abcde'! !

!GRStringTest methodsFor: 'testing-excerpt' stamp: 'lr 2/7/2008 09:31'!
testExcerptEmpty
	self assert: ('' excerpt: '') isNil.
	self assert: ('' excerpt: 'x') isNil.
	self assert: ('x' excerpt: '') isNil! !

!GRStringTest methodsFor: 'testing-excerpt' stamp: 'lr 2/7/2008 09:30'!
testExcerptLeft
	self assert: ('abcde' excerpt: 'd' radius: 0 ellipsis: 'x') = 'xdx'.
	self assert: ('abcde' excerpt: 'd' radius: 1 ellipsis: 'x') = 'xcde'.
	self assert: ('abcde' excerpt: 'd' radius: 2 ellipsis: 'x') = 'xbcde'.
	self assert: ('abcde' excerpt: 'd' radius: 3 ellipsis: 'x') = 'abcde'! !

!GRStringTest methodsFor: 'testing-excerpt' stamp: 'lr 2/7/2008 09:29'!
testExcerptRight
	self assert: ('abcde' excerpt: 'b' radius: 0 ellipsis: 'x') = 'xbx'.
	self assert: ('abcde' excerpt: 'b' radius: 1 ellipsis: 'x') = 'abcx'.
	self assert: ('abcde' excerpt: 'b' radius: 2 ellipsis: 'x') = 'abcdx'.
	self assert: ('abcde' excerpt: 'b' radius: 3 ellipsis: 'x') = 'abcde'! !

!GRStringTest methodsFor: 'testing' stamp: 'jf 9/25/2009 16:49'!
testIncludesSubString
	self assert: ('britney.sex.tape.mkv' beginsWith: 'britney').
	self deny: ('britney.sex.tape.mkv' beginsWith: 'sex')! !

!GRStringTest methodsFor: 'testing-pluralize' stamp: 'lr 2/7/2008 10:21'!
testInflectorAssimilated
	self assert: 'vertice' pluralize = 'vertices'.
	self assert: 'index' pluralize = 'indices'! !

!GRStringTest methodsFor: 'testing-pluralize' stamp: 'lr 2/7/2008 09:11'!
testInflectorCommonSuffixes
	self assert: 'mouse' pluralize = 'mice'.
	self assert: 'synopse' pluralize = 'synopses'.
	self assert: 'man' pluralize = 'men'! !

!GRStringTest methodsFor: 'testing-pluralize' stamp: 'lr 2/7/2008 09:11'!
testInflectorFfffSuffixes
	self assert: 'life' pluralize = 'lives'.
	self assert: 'wolf' pluralize = 'wolves'! !

!GRStringTest methodsFor: 'testing-pluralize' stamp: 'lr 2/7/2008 10:21'!
testInflectorIrregular
	self assert: 'genie' pluralize = 'genies'.
	self assert: 'ox' pluralize = 'oxen'.
	self assert: 'cow' pluralize = 'kine'.
	self assert: 'child' pluralize = 'children'.
	self assert: 'woman' pluralize = 'women'! !

!GRStringTest methodsFor: 'testing-pluralize' stamp: 'mlucas-smith 6/3/2009 22:33'!
testInflectorNotInflecting
	self assert: 'fish' pluralize = 'fish'.
	self assert: 'travois' pluralize = 'travois'.
	self assert: 'chassis' pluralize = 'chassis'.
	self assert: 'nationalities' pluralize = 'nationalities'! !

!GRStringTest methodsFor: 'testing-pluralize' stamp: 'lr 2/7/2008 09:11'!
testInflectorTsssSuffixes
	self assert: 'church' pluralize = 'churches'.
	self assert: 'class' pluralize = 'classes'! !

!GRStringTest methodsFor: 'testing-pluralize' stamp: 'lr 2/7/2008 09:11'!
testInflectorYyyySuffixes
	self assert: 'story' pluralize = 'stories'.
	self assert: 'lady' pluralize = 'ladies'.
	self assert: 'stay' pluralize = 'stays'.! !

!GRStringTest methodsFor: 'testing' stamp: 'jf 12/29/2009 14:14'!
testSubStrings
	"#subStrings: is defined by ANSI 5.7.10.15:
	Answer an array containing the substrings in the receiver separated by the elements of separators."
	| mimeType tokens |
	mimeType := 'application/xhtml+xml'.
	tokens := mimeType subStrings: '/'.
	self assert: tokens size = 2.
	self assert: tokens first = 'application'.
	self assert: tokens second = 'xhtml+xml'.
	
	"ANSI is a bit unclear on how multiple sequential delimiters should be treated.
	Make sure behaviour is consistent for several delimiters in a row (taken from
	Squeak's behaviour)"
	tokens := 'abc,.def.ghi' subStrings: '.,'.
	self assert: tokens size = 3.
	self assert: tokens first = 'abc'.
	self assert: tokens second = 'def'.
	self assert: tokens third = 'ghi'.! !

!GRStringTest methodsFor: 'testing-trim' stamp: 'jf 9/25/2009 16:46'!
testTrimBoth
	self assert: '' trimBoth = ''.
	self assert: ' ' trimBoth = ''.
	self assert: '	' trimBoth = ''.
	self assert: 'foo' trimBoth = 'foo'.
	self assert: ' foo ' trimBoth = 'foo'.
	self assert: '  foo  ' trimBoth = 'foo'.
	self assert: ((String with: Character cr), '   foo  ') trimBoth = 'foo'.
	
	self assert: ('aabbaa' trimBoth: [ :each | each = $a ]) = 'bb'.
	self assert: ('bbaabb' trimBoth: [ :each | each = $a ]) = 'bbaabb'! !

!GRStringTest methodsFor: 'testing-trim' stamp: 'lr 2/7/2008 09:34'!
testTrimLeft
	self assert: '' trimLeft = ''.
	self assert: ' ' trimLeft = ''.
	self assert: '	' trimLeft = ''.
	self assert: 'foo' trimLeft = 'foo'.
	self assert: ' foo ' trimLeft = 'foo '.
	self assert: '  foo  ' trimLeft = 'foo  '.
	
	self assert: ('aabbaa' trimLeft: [ :each | each = $a ]) = 'bbaa'.
	self assert: ('bbaabb' trimLeft: [ :each | each = $a ]) = 'bbaabb'! !

!GRStringTest methodsFor: 'testing-trim' stamp: 'lr 2/7/2008 09:35'!
testTrimRight
	self assert: '' trimRight = ''.
	self assert: ' ' trimRight = ''.
	self assert: '	' trimRight = ''.
	self assert: 'foo' trimRight = 'foo'.
	self assert: ' foo ' trimRight = ' foo'.
	self assert: '  foo  ' trimRight = '  foo'.
	
	self assert: ('aabbaa' trimRight: [ :each | each = $a ]) = 'aabb'.
	self assert: ('bbaabb' trimRight: [ :each | each = $a ]) = 'bbaabb'! !

!GRStringTest methodsFor: 'testing-truncate' stamp: 'lr 2/7/2008 09:32'!
testTruncate
	self assert: ('abc' truncate) = 'abc'.
	self assert: ('abc' truncate: 3) = 'abc'.
	self assert: ('abc' truncate: 2) = 'ab...'.
	
	self assert: ('abc' truncate: 1 ellipsis: '') = 'a'.
	self assert: ('abc' truncate: 0 ellipsis: 'none') = 'none'! !

!GRStringTest methodsFor: 'testing-truncate' stamp: 'lr 2/7/2008 09:32'!
testTruncateEmpty
	self assert: '' truncate = ''! !

TestCase subclass: #GRUtf8CodecTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Grease-Tests-Core'!

!GRUtf8CodecTest methodsFor: 'private' stamp: 'dkh 11/13/2009 15:27'!
asString: aCollectionOfIntegers
	^String streamContents: [ :stream |
		aCollectionOfIntegers do: [ :each |
			stream nextPut: (Character codePoint: each) ] ]! !

!GRUtf8CodecTest methodsFor: 'accessing' stamp: 'dkh 11/13/2009 15:27'!
latin1String
	^ self asString: #(220 98 232 114 115 116 114 238 241 103 233)! !

!GRUtf8CodecTest methodsFor: 'testing' stamp: 'pmm 11/15/2009 10:58'!
testCodecUtf8
	#('UTF-8' 'utf-8') do: [ :codecName |
		| codec |
		codec := GRCodec forEncoding: codecName.
		self assert: codec name = 'utf-8'.
		self assert: codec url name = 'utf-8'.
		self assert: (codec encode: self latin1String) = self utf8String.
		self assert: (codec url encode: self latin1String) = self utf8String.
		self assert: (codec decode: self utf8String) = self latin1String.
		self assert: (codec url decode: self utf8String) = self latin1String ]! !

!GRUtf8CodecTest methodsFor: 'testing' stamp: 'pmm 11/15/2009 10:59'!
testCodecUtf8Binary
	#('UTF-8' 'utf-8') do: [ :codecName |
		| codec binary encoder |
		codec := GRCodec forEncoding: codecName.
		binary := self utf8String asByteArray.
		encoder := codec encoderFor: (WriteStream on: String new).
		encoder binary.
		encoder nextPutAll: binary.
		self assert: encoder contents = binary asString ]! !

!GRUtf8CodecTest methodsFor: 'testing' stamp: 'pmm 11/15/2009 11:00'!
testCodecUtf8Bom
	#('UTF-8' 'utf-8') do: [ :codecName |
		| codec bom |
		codec := GRCodec forEncoding: codecName.
		bom := self asString: #(239 187 191 ).
		self assert: (codec decode: bom , self utf8String) = self latin1String.
		self assert: (codec url decode: bom , self utf8String) = self latin1String ]! !

!GRUtf8CodecTest methodsFor: 'testing' stamp: 'pmm 11/15/2009 11:00'!
testCodecUtf8ShortestForm
	"Non shortest form characters should be rejected
	See Corrigendum #1: UTF-8 Shortest Form http://www.unicode.org/versions/corrigendum1.html"
	#('UTF-8' 'utf-8') do: [ :codecName |
		| codec abc |
		codec := GRCodec forEncoding: codecName.
		abc := self asString: #(193 129 193 130 193 131 ).
		self assert: (codec decode: abc) ~= 'ABC' ]! !

!GRUtf8CodecTest methodsFor: 'accessing' stamp: 'dkh 11/13/2009 15:27'!
utf8String
	^ self asString: #(195 156 98 195 168 114 115 116 114 195 174 195 177 103 195 169)! !
